﻿"use strict";

var UserParams = [];

var QueueWait = false;

var pQ = 0;
var ppQ = 0;
var qL;
var QueueTimerCount = 0;

var ajaxErrors = 0;



// meter queue - processed sequentially using pQ
// but it overridden by priority given to write items and meter read.
// Access alternates between the above block and all the other reads (many are sync)
// Freq write has highest prioriy - needs to be fast and for user to see a fast response.
// Other writes are single buttons or slider events and so can be given high priority
// without impairing any other background functions 


//  param,  abx,  task,     code, jobdata,  priority, requested, xdata
var AjaxQueue = [
	['FREQ',	'A', CAT_WRITE,	'xxxx', 0,	5,	false, 'xxx'],
	['FREQ',	'B', CAT_WRITE,	'xxxx', 0,	2,	false, 'xxx'],
	['BUTN',	'A', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['BUTN',	'B', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['BUTN',	'X', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['SLDR',	'A', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['SLDR',	'B', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['SLDR',	'X', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],
	['DATA',  'X', CAT_WRITE,	'xxxx', 0,	6,	false, 'xxx'],	
	['METR',	'A', CAT_READ,	'xxxx',	0,	1,	false, 'xxx'],
	['METR',	'B', CAT_READ,	'xxxx',	0,	1,	false, 'xxx'],
	['NONE',	'X', CAT_READ,	'xxxx',	0,	0,	false, 'xxx'],
	['MOX',		'X', CAT_READ,  'xxxx', 0,  1,  false, 'xxx'], 
	['FREQ',	'A', CAT_READ,	'xxxx', 0,	2,	false, 'xxx'],
	['FREQ',	'B', CAT_READ,	'xxxx',	0,	2,	false, 'xxx'],
	['BUTN',	'A', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['BUTN',	'B', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['BUTN',	'X', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['SLDR',	'A', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['SLDR',	'B', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['SLDR',	'X', CAT_READ,	'xxxx', 0,	5,	false, 'xxx'],
	['DATA',  'X', CAT_READ,	'xxxx', 0,	6,	false, 'xxx']	
];




function doCallback(param, task, data)
{
	switch(param)
	{
		case 'MOX': 
		{
			if(task == CAT_READ) { getButtonCatCallback(data);}
		  break;
		}		
		case 'METR': 
		{
			if(task == CAT_READ) {getMeterLevelCallback(data);}
		  break;
		}
		case 'FREQ':
		{
			if(task == CAT_READ) {getFreqCatCallback(data);}
  		if(task == CAT_WRITE) {setFreqCatCallback(data);}
			break;
		}
		case 'SLDR':
		{
			if(task == CAT_READ) {getSliderCatCallback(data);}
  		if(task == CAT_WRITE) {setSliderCatCallback(data);}
			break;
		}
		case 'BUTN':
		{
			if(task == CAT_READ) {getButtonCatCallback(data);}
  		if(task == CAT_WRITE) {setButtonCatCallback(data);}
			break;
		}
		case 'DATA':
		{
			if(task == CAT_READ) {getDataCatCallback(data);}
  		if(task == CAT_WRITE) {setDataCatCallback(data);}
			break;
		}
		
		default:
		{
			alert('ajax callback error  ' + param + '   ' + task);
		}
	}
}		


function checkAjaxQueueTimer()    // called at 500ms
{
  if(++QueueTimerCount >= 5)     // 2.5s
  {
  	QueueTimerCount = 0;
  	QueueWait = false;
  }	
}



		
function getCallback(param, task)
{
	switch(param)
	{
		case 'MOX': 
		{
			if(task == CAT_READ) { return getButtonCatCallback;}
		  break;
		}		
		case 'METR': 
		{
			if(task == CAT_READ) { return getMeterLevelCallback;}
		  break;
		}
		case 'FREQ':
		{
			if(task == CAT_READ) {return getFreqCatCallback;}
  		if(task == CAT_WRITE) {return setFreqCatCallback;}
			break;
		}
		case 'SLDR':
		{
			if(task == CAT_READ) {return getSliderCatCallback;}
  		if(task == CAT_WRITE) {return setSliderCatCallback;}
			break;
		}
		case 'BUTN':
		{
			if(task == CAT_READ) {return getButtonCatCallback;}
  		if(task == CAT_WRITE) {return setButtonCatCallback;}
			break;
		}
		case 'DATA':
		{
			if(task == CAT_READ) {return getDataCatCallback;}
  		if(task == CAT_WRITE) {return setDataCatCallback;}
			break;
		}
		
		default:
		{
			alert('ajax callback error  ' + param + '   ' + task);
		}
	}
}		
		
		
function queueInit()
{
	var i
	qL = AjaxQueue.length;
	for(i=0;i<qL;i++)   
	{
		AjaxQueue[i][6] = false;  // kill all requests
	}
}

			
		
// called according to timings table readqueue setting  (eg: 10ms)	
// QueueWait ---   Ajax is async which allow processing to continue whilst awaiting reposnse
// ... but must not send another queued item until reponse ro timeout
// (NB startup array reading is not queued. It used Ajax sync mode with StopRepitasks = true.	
//
// Queue prioritised for freqset and then meter read
// 
function queueNext()
{
	if(QueueWait) return;  
  if(StopRepitasks) return;
  var msgok = false;
	var jobFound = false;
	var vf = 'A';
	var i = 0;
	var priority = false;

	if((VfoRx == 'A') && (AjaxQueue[0][6] == true))
	{
		priority = true;
		jobFound = true;
		ppQ = 0;
		AjaxQueue[0][6] = false;
	}
	else 
	{
		if((VfoRx == 'B') && (AjaxQueue[1][6] == true))
		{
			priority = true;
			jobFound = true;
			ppQ = 1;
			AjaxQueue[1][6] = false;
		}
	}	


	if((ppQ > 10) && (priority == false))             // last item was NOT in for 10 (highg priority)
	{	                       //  So this time process high priority group
		for(i=0;i<11;i++)
		{
			ppQ = i;
			switch(ppQ)
			{
				case 0:
				case 2:
				case 5:
				case 9:
				  {vf = 'A'; break;}
				case 1:
				case 3:
				case 6:
				case 10:
				  {vf = 'B'; break;}
				case 4:
				case 7:
				case 8:
					{vf = 'X'; break;}   
			}
			if((VfoRx == vf) && (AjaxQueue[ppQ][6] == true)) 	
			{
				priority = true;
				jobFound = true;
				AjaxQueue[ppQ][6] = false;
				break;
			}
		}
	}
	
	if(priority == false)     // nothing to do in high priority - so work around the rest using pQ
	{
		ppQ = 12; // force 0-7 next time in case nothing found
		var count = 0;	
		while(jobFound == false)
		{
			if(++count > qL){return;}
			pQ += 1;
			if(pQ >= qL)
			{	
				pQ = 0;
			}
			if(AjaxQueue[pQ][6] == true)	
			{	
				AjaxQueue[pQ][6] = false;
				ppQ = pQ;
				jobFound = true;
			}
		}
	}			

	if(jobFound)
	{
		QueueWait = true;	
		// Following line of code left in to identify parameters
		//		sendWebcatMessage(param, rxab, task, code, jobdata, true, xdata);  			
		msgok = sendWebcatMessage(AjaxQueue[ppQ][0], AjaxQueue[ppQ][1], AjaxQueue[ppQ][2], 
		  							AjaxQueue[ppQ][3], AjaxQueue[ppQ][4], true, AjaxQueue[ppQ][7]); 				
	}
	
}		
	

//  0=param,  1=abx, 2=task, 3=code, 4=jobdata,  5=priority, 6=requested, 7=xdata


function queueWebcatMessage(param, rxab, task, code, jobdata, overwrite, xdata='0')
{
	var jobFound = false;
	var i	
	for(i=0;i<qL;i++)
	{
		if((AjaxQueue[i][0] == param) && (AjaxQueue[i][1] == rxab) && (AjaxQueue[i][2] == task))
		{	
		 	if((overwrite == false) && (AjaxQueue[i][6] == true)) {return false;};
		 	AjaxQueue[i][6] = true;
			AjaxQueue[i][3] = code;
			AjaxQueue[i][4] = jobdata;
			AjaxQueue[i][7] = xdata;
			jobFound = true;
			break;
		}
	}	
	if(jobFound == false) return false;
	return true;
}


function WebcatMsgCallback(data)
{
	alert('Default webCAT message callback function   ' + data + '   ');
}



//sk param  -s-meter etc (enumeration) 
// task   read or set  (enumeration)    
function sendWebcatMessage(param, rxab, task, code, jobdata, opasync, xdata)
{
	var timestamp = (Date.now() % 100000);
	var urlparams = 'rig=' + rig + '&param=' + param  + '&rxab=' + rxab + '&task=' + task 
	              + '&code=' + code + '&jobdata=' + jobdata + '&xdata=' + xdata
	              + '&ts=' + timestamp;	        
	var ajaxreq =
		 $.ajax({                                      
			type: 'GET',
			url: 'cat/phpfiles/wcajaxdata.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: true,  // we prevent caching by adding our own timestamp from Date.now()
		  async: opasync,
		  timeout: 1000,               
		  success: function(data)
		  {
		  	if(parse(data, timestamp) == 0); {ajaxErrors = 0; getCallback(param, task)();}
		  	QueueWait = false;
		  },	  
	    error: function(xmlhttprequest, textstatus, message) 
	    {
	    	if(++ajaxErrors > 2)
	    	{	    	
		    	KillMessageBoxBig();
		    	if(textstatus==="timeout") 
		      {
	      	MessageBoxBig('Client-server timeout ? disconnect  ? wrong rig ?', false);  	      	
					} 
					else 
					{
		      	MessageBoxBig('Client-server error.', false);          
		      }
		      queueInit();
			    doSerialInit();
		      KillMessageBoxBig();
					ajaxErrors = 0;
		    }
	      QueueWait = false;
	    }
		});
	ajaxreq = null;
	urlparams = null; 
}



function parse(data, timestamp)
{	
	var err = 0;
	try{ catParseJSON(data, true);}
  catch(e)
  { 
  	err = DATA_ERROR_IN_PHP_CODE;
  	if(e instanceof SyntaxError) 
  	{ if(data.indexOf('Maximum execution') >= 0){ err = DATA_ERROR_PHP_TIMEOUT; }	}
  }	
	if(err==0){err = catAnswerArray.error;}
	if(err==0)
	{
		if(timestamp != catAnswerArray['ts']) {err = DATA_ERROR_TIMESTAMP;}
	}
	if((err != 0) && (err != XXX_COMMAND))
	{
		$("#ajaxerror").html(rpiErrorString[err]);
		setTimeout(function(){$("#ajaxerror").html("");},3000);
	}
	return err;
}


/////////////////////////



