﻿"use strict";

// band codes
const B160M  = 0;
const B80M   = 1;
const B60M   = 2;
const B40M   = 3;
const B30M   = 4;
const B20M   = 5;
const B17M   = 6;
const B15M   = 7;
const B12M   = 8;
const B10M   = 9;
const B6M    = 10;
const B4M    = 11;
const B2M    = 12;
const B70CM  = 13;

// band button number  - fixed, fixed button selections
var BandButtonList = [
	BTN_160M,  // B160M  = 0
	BTN_80M,   // B80M   = 1
	BTN_60M,   // B60M   = 2
	BTN_40M,   // B40M   = 3
	BTN_30M,	 // B30M   = 4
	BTN_20M,   // B20M   = 5
	BTN_17M,   // B17M   = 6
	BTN_15M,   // B15M   = 7
	BTN_12M,   // B12M   = 8
	BTN_10M,   // B10m   = 9
	BTN_6M,    // B6M    = 10
	BTN_4M,    // B4M    = 11
	BTN_2M,    // B2M    = 12
	BTN_70CM   // B70CM  = 13
]; 


var bandStackCodes ='0000';
 

const LL = 0;   // lower band limit index
const UL = 1;   // upper band limit index

const TUNER_L = 0;
const TUNER_SPAN = 1;
const TUNERX_L = 2;
const TUNERX_SPAN = 3;

var avalBand = 222;
var avalModeBtn = 222;
var bvalBand = 222;
var bvalModeBtn = 222;

var changedVFO = true;


var band = 255;
var lastband = 255;
var prevband = 255;
var tunerband;
var ShowingOOB = false;

var BandWait = false;
var tunerBand = 1;

var PrevTuningPointX;

var bandChanging = false;



var lastbandfreq = [
	0,		// 160m
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0     // 70cm
];	

var lastbandmode = [
	'FF',  //  160m	
	'FF',  //  80m	
	'FF',  //  60m	
	'FF',  //  40m	
	'FF',  //  30m	
	'FF',  //  20m	
	'FF',  //  17m	
	'FF',  //  15m	
	'FF',  //  12m	
	'FF',  //  10m	
	'FF',  //  6m	
	'FF',  //  4m	
	'FF',  //  2m	
	'FF'   //  70cm	
];


/*   // unused
var bandlimit =
[
	[  1800000,   2000000],   //  160m
	[  3500000,   3800000],   //  80m
	[  5258500,   5406500],   //  60m
	[  7000000,   7200000],   //  40m
	[ 10100000,  10150000],   //  30m
	[ 14000000,  14350000],   //  20m
	[ 18068000,  18168000],   //  17m
	[ 21000000,  21450000],   //  15m
	[ 24890000,  24990000],   //  12m
	[ 28000000,  29700000],   //  10m
	[ 50000000,  52000000],   //  6m 
	[ 70000000,  70500000],   //  4m
	[144000000, 146000000],   //  2m
	[430000000, 440000000]   //  70cm
];	
*/

var bandlimit = 
[ [0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0] ];


function setBandLimits()
{
	bandlimit[0][0] = BandsArray[0]['lowedge'];
	bandlimit[0][1] = BandsArray[0]['highedge'];
	bandlimit[1][0] = BandsArray[1]['lowedge'];
	bandlimit[1][1] = BandsArray[1]['highedge'];
	bandlimit[2][0] = BandsArray[2]['lowedge'];
	bandlimit[2][1] = BandsArray[2]['highedge'];
	bandlimit[3][0] = BandsArray[3]['lowedge'];
	bandlimit[3][1] = BandsArray[3]['highedge'];
	bandlimit[4][0] = BandsArray[4]['lowedge'];
	bandlimit[4][1] = BandsArray[4]['highedge'];
	bandlimit[5][0] = BandsArray[5]['lowedge'];
	bandlimit[5][1] = BandsArray[5]['highedge'];
	bandlimit[6][0] = BandsArray[6]['lowedge'];
	bandlimit[6][1] = BandsArray[6]['highedge'];
	bandlimit[7][0] = BandsArray[7]['lowedge'];
	bandlimit[7][1] = BandsArray[7]['highedge'];
	bandlimit[8][0] = BandsArray[8]['lowedge'];
	bandlimit[8][1] = BandsArray[8]['highedge'];
	bandlimit[9][0] = BandsArray[9]['lowedge'];
	bandlimit[9][1] = BandsArray[9]['highedge'];
	bandlimit[10][0] = BandsArray[10]['lowedge'];
	bandlimit[10][1] = BandsArray[10]['highedge'];
	bandlimit[11][0] = BandsArray[11]['lowedge'];
	bandlimit[11][1] = BandsArray[11]['highedge'];
	bandlimit[12][0] = BandsArray[12]['lowedge'];
	bandlimit[12][1] = BandsArray[12]['highedge'];
	bandlimit[13][0] = BandsArray[13]['lowedge'];
	bandlimit[13][1] = BandsArray[13]['highedge'];
	

}

// Note  - band limits are in the databas ebands table
// piWebCAT will switch band when the frequenct enters these limits
// BUT .. the band tuner start and span have to be fixed to the tunign scalew
// and are specified below

var bandtuner =
[
	[  1800000,   200000,  20, 680],   //  160m
	[  3500000,   300000,  20, 690],   //  80m
	[  5255000,   155000,  20, 682],   //  60m
	[  7000000,   200000,  20, 680],   //  40m
	[ 10100000,    50000,  20, 675],   //  30m
	[ 14000000,   350000,  20, 665],   //  20m
	[ 18065000,   105000,  20, 672],   //  17m
	[ 21000000,   450000,  20, 675],   //  15m
	[ 24890000,   100000,  20, 680],   //  12m
	[ 28000000,  1700000,  20, 680],  //  10m
	[ 50000000,  2000000,  20, 680],   //  6m 
	[ 70000000,   500000,  20, 680],   //  4m    provisional - no tuner yet
	[144000000,  2000000,  20, 680],   //  2m    
	[430000000, 10000000,  20, 680]   //  70cm 
];	


function doTuningPoint(f)
{
	if(band > B70CM) return;
	var x = bandtuner[band][TUNERX_L]  + ((f - bandtuner[band][TUNER_L]) * bandtuner[band][TUNERX_SPAN]) / bandtuner[band][TUNER_SPAN];
	PrevTuningPointX = x;
	drawTuningPoint(Math.floor(x), "red");
}

	
	

function freqBand(f)
{
	var prevband = band;
	var a = 0;
	if(f > 10000000) a = 4;
	if(f > 24000000) a = 8;
	var i;
	for(i=a;i<14;i++)
	{
		if(f <= bandlimit[i][UL])
		{
			if(f >= bandlimit[i][LL]) return i;
	  }
	}
	return 255;
}


function checkBandMain()
{
	if(Transmitting) return;
	if(StopRepitasks) return;
	band = freqBand(freqMain);
	if(band == 255)
	{
		band = prevband;  /// dont trigger a reload on leabing band range
		if(band == 255)
		{
			MessageBoxBig('? no connection.   ? out of band ?', false);
			ShowingOOB = true;
			return;
		}
	}
	if((band != tunerBand) && (band != 255))
	{
	  displayBand(band);
  	tunerBand = band;
	}
	
	if(band == prevband)
	{
		lastband = band;
		lastbandfreq[band] = freqMain;
		bandChanging = false;
	};
	if(bandChanging) return;
	
	if(ShowingOOB)
	{
		ShowingOOB = false;
		KillMessageBoxBig();
	}
		

	if((band != prevband) && (bandChanging == false) && (BandWait == false))
	{
		getMoxStatus();
		bandChanging = true;
		killRepeater();
  	setTimeout(afterMoxBand, 1000);  // wait for MOX repsonse
	} 
	else // no band change 
	{
	 	lastband = band;
		lastbandfreq[band] = freqMain;
		if((changedVFO) ||  (tunerBand != band))
		{
		 	setTimeout(afterMoxBand, 1500);  // wait for band change reposnse	
		 	BandWait = true;
		}		
	}
	 
	changedVFO = false;
}


// The complexity here is to cope with
// split cross band working. - delay to wait for MOX read response
// or VFO change  - delay to wait for band response.
// on switching to transmit with PTT, band change is picked up before
// the ?1000ms MOX check can detect the transmit status.
// Problem is that of stopping a button aslider reload
// Solution - do a mox check and then wait 500ms
// ... If transmitting   set badn back to prevband
// if not then check than band is still changed
//   ... this is for a short PTT press where Tx status is not checked 

function afterMoxBand()
{
	var prevbtnno;
	var arrayIndex = 0;
	if(Transmitting)
	{
	  bandChanging = false;
	  band = prevband;
	  BandWait = false;
	  return;
	}			
	band = freqBand(freqMain);
	if(band == prevband)
	{
		bandChanging = false;
		ResetOrReload();
		changedVFO = false;
  }
  else
  {
  	// CIV band setting reads the latest of the three band stacking register frequencies
  	// for the band and then sends that frequency to change band.
  	// Frequency monitoring then detects the band change and chnaages scale, button highlighting
  	// When we leave a band we record the old band frequency, and pick up the old band 
  	// band stack code (eg 0703) from ButtonArray.
  	// We then set a timeout for sendBackStack(). This, on the server  reads the old band's
  	// band stacking entry, modifies it with the last old band freq  and writes it back to the rig
  	// Result:   On return to the band we have he latest freq for that band restored 
  	if((catcomms == 'CIV') && (prevband < 14))
		{			
  		prevbtnno = BandButtonList[prevband];
  		arrayIndex = getButtonArrayIndex(prevbtnno);
  		bandStackCodes = ButtonArray[arrayIndex]['bgsdata'];
  		setTimeout(sendBandStack, 500);	
  	}	
  	displayBand(band);
  	tunerBand = band;
		ResetOrReload();
  	prevband = band;	
  	bandChanging = false;
	}	
	BandWait = false;
}


function sendBandStack()
{
	queueWebcatMessage('DATA', 'X', CAT_WRITE, 'BSTK', bandStackCodes, true,  lastbandfreq[lastband]);
}


function ResetOrReload()
{
	killRepeater(); 
	var needReload = false;
  if(VfoRx == 'A') 
  {
  	if(avalBand != band) {needReload = true;};
  	avalBand = band;
	}
  if(VfoRx == 'B') 
  {
  	if(bvalBand != band) {needReload = true;};
  	bvalBand = band;
	}
	if(needReload)
	{
		rigReload();
	}
	else
	{
		resetButtons();
		resetSliders();
	}
}


function setBand(band)
{
	var jobdata = band.toString(10);
	queueWebcatMessage('BAND', VfoRx, CAT_WRITE, 'BAND', jobdata, true, 0);
}



function setBandCallback(data)
{
	//var catAnswerArray = new Array();
	var err = 0;
	try{ var catAnswerArray = JSON.parse(data);}
  catch(e)
  { 
  	err = DATA_ERROR_IN_PHP_CODE;
  	if(e instanceof SyntaxError) 
  	{ if(data.indexOf('Maximum execution') >= 0){ err = DATA_ERROR_PHP_TIMEOUT; }	}
  }	
	if(err==0){err = catAnswerArray.error;}
	catAnswerArray = null;
	if(err != 0) { return; }
  
}
	


function deactivateBandButtons()
{
	var xactive;
	var xbtnno;
	var xbtncolor;
	var xindex;
	var xid;
	for(var i in ButtonArray)
	{  
		if((ButtonArray[i]['action'] == 'G')  && (ButtonArray[i]['code'] == 'BAND'))
		{
			xactive = ButtonArray[i]['active'];
			xbtnno = ButtonArray[i]['btnno'];		
			xbtncolor = ButtonArray[i]['color'];
			xindex = getButtonListIndex(xbtnno);
			xid = ButtonList[xindex][1];
			ButtonInactivate(xid, xactive, xbtncolor, i);
		}	 
	}
}


function buttonActive(id)
{
	$(id).css('background-color','gold');
	$(id).css('color','black');		
}



function displayBand(b)
{	
	if(b != 255) tunerband = b;
	deactivateBandButtons();
	switch(b)
	{
		case B160M: 
			{
				buttonActive('#btn160m');		
				drawTuner160m();
				break;
			}
		case B80M: 
			{
				buttonActive('#btn80m');		
				drawTuner80m();
				break;
			}
		case B60M: 
			{
				buttonActive('#btn60m');	
				drawTuner60m();
				break;
			}
		case B40M: 
			{
				buttonActive('#btn40m');	
				drawTuner40m();
				break;
			}
		case B30M: 
			{
				buttonActive('#btn30m');	
				drawTuner30m();
				break;
			}
		case B20M: 
			{
				buttonActive('#btn20m');	
				drawTuner20m();
				break;
			}
		case B17M: 
			{
			
				buttonActive('#btn17m');	
				drawTuner17m();
				break;
			}
		case B15M: 
			{
				buttonActive('#btn15m');	
				drawTuner15m();
				break;
			}
		case B12M: 
			{
				buttonActive('#btn12m');	
				drawTuner12m();
				break;
			}
		case B10M: 
			{
				buttonActive('#btn10m');	
				drawTuner10m();
				break;
			}
		case B6M: 
			{
				buttonActive('#btn6m');	
				drawTuner6m();
				break;
			}
		case B4M: 
			{
				buttonActive('#btn4m');	
				drawTuner4m();
				break;
			}			
		case B2M: 
			{
				buttonActive('#btn2m');	
				drawTuner2m();
				break;
			}
		case B70CM: 
			{
				buttonActive('#btn70cm');	
				drawTuner70cm();
				break;
			}
			
		default:
			{	
				drawTuningPoint(Math.floor(PrevTuningPointX), "olive");
				break;
			}
	}
}			


/////////////////////////////////////////////////