﻿"use strict";


// button enumeration   (excluding band switching)

const BTN_160M	= 2;
const BTN_80M 	= 3;
const BTN_60M 	= 4;
const BTN_40M 	= 5;
const BTN_30M 	= 6;
const BTN_20M 	= 7;
const BTN_17M 	= 8;
const BTN_15M 	= 9;
const BTN_12M		= 10;
const BTN_10M 	= 11;
const BTN_6M		= 12;
const BTN_4M		= 13;
const BTN_2M		= 14;
const BTN_70CM	= 15;


const BTN_VFOA	= 16;
const BTN_VFOB	= 17;


const BTN_018	= 18;
const BTN_019	= 19;
const BTN_020	= 20;
const BTN_021	= 21;
const BTN_022	= 22;
const BTN_023 = 23;
const BTN_024 = 24;
const BTN_025 = 25;
const BTN_026 = 26;


const BTN_031 	= 31;
const BTN_032		= 32;
const BTN_033		= 33;
const BTN_034		= 34; 

const BTN_037 	= 37;
const BTN_038 	= 38;

const BTN_LSB		= 40;
const BTN_USB		= 41;
const BTN_CW		= 42;
const BTN_MODEA	= 43;
const BTN_MODEB	= 44;
const BTN_MODEC	= 45;
const BTN_MODED = 46;

const DEF_051		= 51;
const DEF_052		= 52;
const DEF_053		= 53;
const DEF_054		= 54;
const DEF_055		= 55;
const DEF_056		= 56;

const BTN_058	= 58;

const BTN_MOX		= 59;

const BTN_TX_METER_A		= 61;
const BTN_TX_METER_B		= 62;
const BTN_TX_METER_C	 	= 63;
const BTN_TX_METER_D		= 64;
const BTN_TX_METER_E		= 65;

const BTN_066	= 66;
const BTN_067	= 67;
const BTN_068	= 68;
const BTN_069	= 69;
const BTN_070	= 70;
const BTN_071	= 71;
const BTN_072 = 72;


const BTN_075	= 75;
const BTN_076	= 76;
const BTN_SWAPAB	= 79;
const BTN_080	= 80;
const BTN_081	= 81;
const BTN_082 = 82;
const BTN_083 = 83;

const DEF_089 = 89;
const DEF_090 = 90;

const BTN_100 = 100;
const BTN_101 = 101;
const BTN_102 = 102;
const BTN_103 = 103;
const BTN_104 = 104;
const BTN_105 = 105;
const BTN_106 = 106;

const BTN_MORE_11 = 111;
const BTN_MORE_12 = 112;
const BTN_MORE_13 = 113;
const BTN_MORE_14 = 114;
const BTN_MORE_15 = 115;
const BTN_MORE_16 = 116;
const BTN_MORE_21 = 121;
const BTN_MORE_22 = 122;
const BTN_MORE_23 = 123;
const BTN_MORE_24 = 124;
const BTN_MORE_25 = 125;
const BTN_MORE_26 = 126;
const BTN_MORE_31 = 131;
const BTN_MORE_32 = 132;
const BTN_MORE_33 = 133;
const BTN_MORE_34 = 134;
const BTN_MORE_35 = 135;
const BTN_MORE_36 = 136;
const BTN_MORE_41 = 141;
const BTN_MORE_42 = 142;
const BTN_MORE_43 = 143;
const BTN_MORE_44 = 144;
const BTN_MORE_45 = 145;
const BTN_MORE_46 = 146;


//////////////////////////////////////////////////////////

var CurrentMode = 'LSB';


var ResetButtonsList = [
	[DEF_051,		"btn051"],
	[DEF_052,		"btn052"],
	[DEF_053,		"btn053"],
	[DEF_054,		"btn054"],
	[DEF_055,		"btn055"],
	[DEF_056,		"btn056"],
	[DEF_089,		"btn089"],
	[DEF_090,		"btn090"],
];



	// fields:   btnno .. as used in onPwcclick()  , id    ,   on/off record  ( or 1) 
var ButtonList = [	
	[BTN_TX_METER_A,		"btnTxmA",		0],
	[BTN_TX_METER_B,		"btnTxmB",		0],
	[BTN_TX_METER_C, 		"btnTxmC",		0],
	[BTN_TX_METER_D,		"btnTxmD",		0],
	[BTN_TX_METER_E,		"btnTxmE",		0],
	[BTN_066,			"btn066",		0],
	[BTN_067,			"btn067",		0],
	[BTN_068,			"btn068",		0],
	[BTN_069,			"btn069",		0],
	[BTN_070,			"btn070",		0],
	[BTN_071,			"btn071",		0],
	[BTN_072,  		"btn072",		0],
	[BTN_075,			"btn075",		0],
	[BTN_076,			"btn076",		0],
	[BTN_VFOA,		"btnVFOA",	0],
	[BTN_VFOB,		"btnVFOB",	0],
	[BTN_SWAPAB,	"btnSwapAB",0],
	[BTN_080,			"btn080",		0],
	[BTN_081,			"btn081",		0],
	[BTN_082, 		"btn082",		0],
	[BTN_083, 		"btn083",		0],
	[BTN_037, 		"btn037",		0],
	[BTN_038, 		"btn038",		0],
	[BTN_018, 		"btn018",		0],
	[BTN_019,	 		"btn019",		0],
	[BTN_020,			"btn020",		0],
	[BTN_021, 		"btn021",		0],
	[BTN_022, 		"btn022",		0],
	[BTN_031, 		"btn031",		0],
	[BTN_032, 		"btn032",		0],
	[BTN_033,			"btn033",		0],
	[BTN_034, 		"btn034",		0],	
	[BTN_LSB,     "btnLSB",		0],
	[BTN_USB,			"btnUSB",		0],
	[BTN_CW,			"btnCW",		0],
	[BTN_MODEA,		"btnModeA",	0],
	[BTN_MODEB,		"btnModeB",	0],
	[BTN_MODEC,		"btnModeC",	0],
	[BTN_MODED, 	"btnModeD",	0],

	[DEF_051,			"sliderIfWidth",		0],
	[DEF_052,			"slider008",	0],
	[DEF_053,			"slider009",	0],
	[DEF_054,			"slider010",	0],
	[DEF_055,			"slider011",	0],
	[DEF_056,			"slider012",	0],
	[DEF_089,			"slider029",	0],
	[DEF_090,			"slider030",	0],

	[BTN_058,		"btn058",	0],

	[BTN_MOX,		"btnMOX",		0],

	[BTN_160M,		"btn160m",	0],
	[BTN_80M, 		"btn80m",		0],
	[BTN_60M, 		"btn60m",		0],
	[BTN_40M, 		"btn40m",		0],
	[BTN_30M, 		"btn30m",		0],
	[BTN_20M, 		"btn20m",		0],
	[BTN_17M, 		"btn17m",		0],
	[BTN_15M, 		"btn15m",		0],
	[BTN_12M,			"btn12m",		0],
	[BTN_10M, 		"btn10m",		0],
	[BTN_6M,			"btn6m",		0],
	[BTN_4M,			"btn4m",		0],
	[BTN_2M,			"btn2m",		0],
	[BTN_70CM,		"btn70cm",	0],


	[BTN_023, 	"btn023",		0],
	[BTN_024, 	"btn024",		0],
	[BTN_025, 	"btn025",		0],
	[BTN_026, 	"btn026",		0],	
	[BTN_100,		"btn100",		0],
	[BTN_101, 	"btn101",		0],
	[BTN_102, 	"btn102",		0],
	[BTN_103, 	"btn103",		0],
	[BTN_104, 	"btn104",		0],
	[BTN_105, 	"btn105",		0],
	[BTN_106, 	"btn106",		0],
	
	[BTN_MORE_11, "btnmore11",  0],
	[BTN_MORE_12, "btnmore12",  0],
	[BTN_MORE_13, "btnmore13",  0],
	[BTN_MORE_14, "btnmore14",  0],
	[BTN_MORE_15, "btnmore15",  0],
	[BTN_MORE_16, "btnmore16",  0],
	[BTN_MORE_21, "btnmore21",  0],
	[BTN_MORE_22, "btnmore22",  0],
	[BTN_MORE_23, "btnmore23",  0],
	[BTN_MORE_24, "btnmore24",  0],
	[BTN_MORE_25, "btnmore25",  0],
	[BTN_MORE_26, "btnmore26",  0],
	[BTN_MORE_31, "btnmore31",  0],
	[BTN_MORE_32, "btnmore32",  0],
	[BTN_MORE_33, "btnmore33",  0],
	[BTN_MORE_34, "btnmore34",  0],
	[BTN_MORE_35, "btnmore35",  0],
	[BTN_MORE_36, "btnmore36",  0],
	[BTN_MORE_41, "btnmore41",  0],
	[BTN_MORE_42, "btnmore42",  0],
	[BTN_MORE_43, "btnmore43",  0],
	[BTN_MORE_44, "btnmore44",  0],
	[BTN_MORE_45, "btnmore45",  0],
	[BTN_MORE_46, "btnmore46",  0]
];
	
// reste buttons - ids in the ButtonList are those of the slider
// this list hold the butt0n id inorder to flash on click	
	
var ResetList = [	
	[DEF_051,		"btn051"],
	[DEF_052,		"btn052"],
	[DEF_053,		"btn053"],
	[DEF_054,		"btn054"],
	[DEF_055,		"btn055"],
	[DEF_056,		"btn056"],
	[DEF_089,		"btn089"],
	[DEF_090,		"btn090"]
];


var lastCWME = 'Z';
var cwRepeaterRunning = false;   // sec
var cwRepeatOn = false;
var cwRepeatInterval = 0;
var cwActiveRepeatInterval = 0;
var cwRepeatId;

var TXMbtnno;

var ModeButtonMessageEnable = true;
var ButtonMessageEnable = true;

var widthA = 2800;   // HMALIB only
var widthB = 2800;   // HAMLIB only

var modeA = "LSB";   // HAMLIB only
var modeB = "LSB";   // HAMLIOB only

var ButtonBlockTimeout;
var currentRowid;   // Used in station log editing
////////////////////////////////////////////////////////

var xcode = '';



////////////////////////////////////////////////////

function closeMoreButtons()
{
	divToggle('popMoreButtons',0);	
	moreShowing = false;
}


function closeDebug()
{
	divToggle('popDebug',0);
		
}


function getButtonArrayIndex(btnno)  // n is btnno 		
{
	for(var i in ButtonArray)
	{
		if(btnno == ButtonArray[i]['btnno']) {return i;};
	}	
	return 255;
}


function getButtonListIndex(btnno)
{
	var i;
	for(i=0;i<ButtonList.length;i++)
	{
		if(ButtonList[i][0] == btnno) {return i;};   
	}
	return 255;
}


function getResetListId(btnno)
{
	var i;
	for(i=0;i<ResetList.length;i++)
	{
		if(ResetList[i][0] == btnno) {return ResetList[i][1];};   
	}
	return "";
}




function ButtonActivate(id, arrayIndex)
{
	if(ButtonArray[arrayIndex]['active'] == 'L')
	{ 
		var color = ButtonArray[arrayIndex]['color'];
		$("#" + id).css("background-color",color);		
		$("#" + id).css("color","black");	
		return;
	}
	
	if(id == "btnMOX")
	{	
		$("#" + id).css("background-color","yellow");
		if(split)
		{
			$("#freqnosel").css("color","#FF4040");
		}
		else
		{
			$("#freqsel").css("color","#FF4040");
		}
		Transmitting = true;
	}
	else
	{$("#" + id).css("background-color","gold");}
	$("#" + id).css("color","black");

	if(ButtonArray[arrayIndex]['code'] == 'MODE')
	{
		var caption = ButtonArray[arrayIndex]['caption'];
		$("#ModeRxSel").html(caption);
	}
}


function getButtonArrayIndexFromCode(code) 		// finds first one
{	
	for(var i in ButtonArray)
	{
		if(code == ButtonArray[i]['code']) {return i;};
	}	
	return 255;
}
	


function ButtonInactivate(id, active, btncolor, arrayIndex)
{
	if(active == 'N') return;	
	if(ButtonArray[arrayIndex]['active'] == 'L')
	{ 
		$("#" + id).css("background-color",'black');		
		$("#" + id).css("color","red");	
		return;
	}
	if(id == "btnMOX") 
	{
		if(VfoRx == 'A')
		{
			$("#freqsel").css("color","yellow");
			$("#freqnosel").css("color","orange");		
		}
		else
		{
			$("#freqsel").css("color","orange");
			$("#freqnosel").css("color","yellow");		
		}
		Transmitting = false;
	}
	$("#" + id).css("background-color", btncolor);
	$("#" + id).css("color","");
}


//////////////////////////////////////////////


function InitialiseMeterButtons()
{
	$("#btnTxmA").css("background-color","gold");   // set BTN_TX_METER_A
	$("#btnTxmA").css("color","black");
	////////////////////////////////////
	$("#btnTxmB").css("background-color","");   // clear the other four
	$("#btnTxmB").css("color","");
	$("#btnTxmC").css("background-color",""); 
	$("#btnTxmC").css("color","");
	$("#btnTxmD").css("background-color","");
	$("#btnTxmD").css("color","");
	$("#btnTxmE").css("background-color","");
	$("#btnTxmE").css("color","");
	TXMbtnno = BTN_TX_METER_A;
}
///////////////////////////////////////////////////////



function setVFO(ab)
{
	if(ab == 'A')
	{	
		VfoRx = 'A'; 
		VfoTx = 'A';
		$("#btnVFOA").css("background-color","gold"); 
		$("#btnVFOA").css("color","black");
		$("#btnVFOB").css("background-color","");   
		$("#btnVFOB").css("color","");
		if(Transmitting == false){$("#freqsel").css("color","yellow");}
		$("#freqnosel").css("color","orange");
	}
	if(ab == 'B')
	{
		VfoRx = 'B'; 
		VfoTx = 'B';
		$("#btnVFOB").css("background-color","gold"); 
		$("#btnVFOB").css("color","black");
		$("#btnVFOA").css("background-color","");   
		$("#btnVFOA").css("color","");
		if(Transmitting == false){$("#freqsel").css("color","orange");}
		$("#freqnosel").css("color","yellow");
	}
}


function getVfoAB()
{
	sendWebcatMessage('BUTN', 'X', CAT_READ, 'VFO', 0, false);	
}



//////////////////////////////////////////////////////////////

function resetButtons()
{
	var code;
	var action;
	var btnno;
	var listIndex;
	var active;
	var vx;
	var bon;
	var btncolor;
	var id;		
	for(var i in ButtonArray)
	{
		code = ButtonArray[i]['code'];
		if(code == 'BAND'){continue;};
		action = ButtonArray[i]['action'];
		active = ButtonArray[i]['active'];
		btncolor = ButtonArray[i]['color'];
		if(code == '') {continue;};
		if((active == 'N') || (action == 'S') || (action == 'R') || (action == 'M')) {continue;};		
		btnno = ButtonArray[i]['btnno'];  
		listIndex = getButtonListIndex(btnno);
		id = ButtonList[listIndex][1];
		vx = ButtonArray[i]['vx'];
		if(code == 'RPGO'){ButtonInactivate(id, active, btncolor, i);};	
		if(vx != 'V') {continue;};
		if(VfoRx == 'A') {bon = ButtonArray[i]['aval'];}; 
		if(VfoRx == 'B') {bon = ButtonArray[i]['bval'];};
		if(bon == 1)
		{
			ButtonActivate(id, i);
			if(code == 'SPLT') {split = true;};
			ButtonList[listIndex][2]  = 1;
		}
		else
		{
			ButtonInactivate(id, active, btncolor, i);
			if(code == 'SPLT') {split = false;};
			ButtonList[listIndex][2]  = 0;		
		}	
	}
}		
		
		
function charIsUpper(ch)
{
	if((ch >= 'A') && (ch <= 'Z')) 
	{return true;}
	else 
	{return false;} 
}		
		


function getButtonCatCallback()
{	
	var i;
	var bon;
  var listIndex;
  var xbtncolor;
  var xindex;
  var xcaption;
  var xset;
  var xcat;
  var xid;
  var xbtnno;
  var passband;
  var cat = catAnswerArray["value"];
  var code = catAnswerArray['code'];
  var rxab = catAnswerArray['rxab'];
  var scat = cat.toString();
	passband = 0;	
	if((catcomms == 'HAMLIB') && (code != 'VFO'))
	{		
		if(scat.substring(0,4) === 'RPRT'){return;}  // NRSW with mode = FM
		if(charIsUpper(cat[0]))
		{		
			for(i=1;i<7;i++)
			{
				if(!charIsUpper(cat[i]) && (cat[i] != '|') && (cat != ' '))
				{
					if((code == 'MODE') || (code == 'SPMD'))
					{
						passband = parseInt(cat.substr(i+1));
						if(vfomode == 'N')
						{
							displayWidthTextbox('WRXX',passband); widthA = passband;
							drawSlider(passband, "IFWD", 'X');	
						}
						if(vfomode == 'Y')
						{						
							if(rxab == 'A') {displayWidthTextbox('WRXA',passband); widthA = passband;};
							if(rxab == 'B'){displayWidthTextbox('WRXB',passband); widthB = passband;};				
							if(rxab == VfoRx) {drawSlider(passband, "IFWD", rxab);};	
					  }
					}
					cat = cat.substr(0,i);  // mode  > for button selection ect
					break;
				}
			}	
		}
		else
		{
			cat = parseInt(cat);
		}
  }
  var seton;
  var anson;
  var setoff;
  var ansoff;
  
	var BA = ButtonArray;
 
  if(code == 'CWRP') {return;}
  if(code == 'BAND'){return;}; 
	var arrayIndex = getButtonArrayIndexFromCode(code);
	var btnno = ButtonArray[arrayIndex]['btnno'];  
	if(catcomms == 'CIV')
	{
		seton = BA[arrayIndex]['von'];
		anson = seton;
		setoff = BA[arrayIndex]['voff'];
		ansoff = setoff;
	}
	else
	{
		seton = BA[arrayIndex]['seton'];
		anson = BA[arrayIndex]['anson'];
		setoff = BA[arrayIndex]['setoff'];
		ansoff = BA[arrayIndex]['ansoff'];
	}
	var action = BA[arrayIndex]['action'];
	var btncolor = BA[arrayIndex]['color'];
	var active = BA[arrayIndex]['active'];
	if(active == 'N') return;	
	if((active != 'Y') && BlockButtonSync) return;
	if(action == 'T') //|| (active == 'L'))
	{
		listIndex = getButtonListIndex(btnno);
		var id = ButtonList[listIndex][1];
		if(cat == anson) 
		{
			bon = 1; // on
			ButtonActivate(id, arrayIndex);
			if(code == 'SPLT') {split = true;};
			ButtonList[listIndex][2]  = 1;		
		} 
		else 
		{
			bon = 0; //  off
			ButtonInactivate(id, active, btncolor, arrayIndex);
			if(code == 'SPLT') {split = false;};
			ButtonList[listIndex][2]  = 0;
		};	
		if(VfoRx == 'A') {BA[arrayIndex]['aval'] = bon;};
		if(VfoRx == 'B') {BA[arrayIndex]['bval'] = bon;};
  }
  var ModeButtonFound = false;
  var ButtonFound = false;
  if(action == 'G')
  {
		for(i in BA)
		{  
			if((BA[i]['action'] == 'G') && (BA[i]['code'] == code))
			{
				xbtnno = BA[i]['btnno'];
				xindex = getButtonListIndex(xbtnno);
				xid = ButtonList[xindex][1];
				xcaption = BA[i]['caption'];
				xbtncolor = BA[i]['color'];
				if(catcomms == 'CIV')
				{
					xcat = BA[i]['bgsdata'];
					xset = xcat;
				}
				else
				{
					xcat = BA[i]['nans']; 
					xset = BA[i]['nset'];
				}
				if((code == 'MODE') && (rxab == VfoRx) && splitCompare(cat, xcat)) //(xcat == cat))
				{
					ModeButtonFound = true;
					lastbandmode[band] = xset;
				};		
				 
				if((catcomms == 'HAMLIB') && (code == 'MODE'))  
				{
					if(rxab == 'A'){modeA = cat;}
					if(rxab == 'B'){modeB = cat;}
				}		
				var NoSelMode = ((code == 'MODE') && (rxab != VfoRx));								
				xcode = code;
			  if(splitCompare(cat, xcat))
				{
					ButtonFound = true;
					if(NoSelMode)
					{
						$("#ModeRxNoSel").html(xcaption);						
						return;
					}					
					bon = 1; //  on
					if(code == 'VFO')
					{					
						if((xbtnno == BTN_VFOB) && (VfoRx == 'A') && (btnVfoBinactive == false)) {SetAudioAB(); setVFO('B');}
						if((xbtnno == BTN_VFOA) && (VfoRx == 'B') && (btnVfoAinactive == false)) {SetAudioAB(); setVFO('A');}
 					}
					if((rxab == VfoRx) || (rxab == 'X'))
					{ 
						ButtonActivate(xid, i);
						if(code == 'MODE') 
						{
							$("#ModeRxSel").html(xcaption);
							CurrentMode = xcaption;
						}
					}	
				}
				else
				{
					if(NoSelMode){continue;};
					bon = 0; // off
					ButtonInactivate(xid, 'Y', xbtncolor, i);	
				}
				if(rxab == 'A') {BA[i]['aval'] = bon;};   // store cat in all of group
				if(rxab == 'B') {BA[i]['bval'] = bon;};										
			}	 
		}
		if((code == 'MODE') && (ModeButtonFound == false))
		{
			if(ModeButtonMessageEnable)
			{
				var msg = "Mode data: " + cat + "  returned from the radio.<br>"
				        	+ "There is no Mode button configured with this data id.<br>"
				        	+ "A mode selected on the rig has no matching button in piWebCAT.<br>"
				        	+ "Typical causes are CW-U / CW-L  or CR / CWR in Hamlib.<br>"
				        	+ "This message will not occur again without a restart"; 
				ModeButtonMessageEnable = false;
				MessageBox(msg, true);
			}
		}		
		else
		{ 
			if((ButtonFound == false) && ButtonMessageEnable)
			{
				var msg = "Code: " + cat + "  returned from the radio for button group: " + code + ".<br>"
				          + "An option selected on the rig has no matching button in piWebCAT.<br>"
				          + "An example is AGC OFF or AUTO when you have only configured fast, med and slow.<br>"
				        	+ "This message will not occur again without a restart"; 
 				ButtonMessageEnable = false;
 				MessageBox(msg, true);
			}
		}	
  }
}



function splitCompare(xcat, cat)
{
	var i = 0;
	var xcats = xcat.toString();
	var catArray = cat.split('|');
	var n = catArray.length;
	var cats = '';
	if(n ==0) return false;
	for(i=0;i<n;i++)
	{
		cats = catArray[i];
		if(cats.trim() == xcats.trim()){ return true;}
	}
	return false;
}


function setButtonCatCallback()  // timing - this callback from server  - not radio!!
{
}



function setButtonVals(arrayIndex, bon, vx)
{
	if(vx != 'V') return;
	if(VfoRx == 'A') {ButtonArray[arrayIndex]['aval'] = bon;};
	if(VfoRx == 'B') {ButtonArray[arrayIndex]['bval'] = bon;};				
}




function killRepeater()
{
	clearInterval(cwRepeatId);
	cwRepeaterRunning = false;   
	cwRepeatOn = false;	
}


function setCwRepeatInterval(sec)
{
	cwRepeatInterval = sec;
	if(sec == cwActiveRepeatInterval){return;};
	if(cwRepeaterRunning)
	{
		clearInterval(cwRepeatId);
		cwActiveRepeatInterval = cwRepeatInterval;
		cwRepeatId = setInterval(repeatCwMessage, 1000*cwRepeatInterval);
	}
	else
	{
		if(cwRepeatOn)
		{
			cwActiveRepeatInterval = cwRepeatInterval;			
			cwRepeaterRunning = true;
			cwRepeatId = setInterval(repeatCwMessage, 1000*cwRepeatInterval);
		}
	}		
}



function cwMessageRepeater(onoff)
{
	cwRepeatOn = onoff;
	if(cwRepeatInterval == 0) {return;};  
	if(cwRepeaterRunning) 
	{
		if(cwActiveRepeatInterval	!= cwRepeatInterval)
		{
			clearInterval(cwRepeatId);
			cwRepeaterRuning = false;
		}		
	}
	if((cwRepeaterRunning == false) && (onoff > 0))
	{
		cwActiveRepeatInterval = cwRepeatInterval;
		cwRepeaterRunning = true;
		cwRepeatId = setInterval(repeatCwMessage, 1000*cwRepeatInterval);
	}
}


function repeatCwMessage()
{
	if((lastCWME == 'Z') || (cwRepeatOn == false) || (cwRepeatInterval == 0)) { return;};
	queueWebcatMessage('BUTN', 'X', CAT_WRITE, 'CWME', lastCWME, true, 0);
}




function unblockButtonSync()
{
	BlockButtonSync = false;
}


function RestoreResetButton(resetid)
{
	var s = "#" + resetid;
	$(s).css("background-color", "");
	$(s).css("color","");
}


function buttonTxBlock(btnno)
{
	if(Transmitting)
	{
		switch(btnno)
		{
			case BTN_MOX:
			case BTN_TX_METER_A:
			case BTN_TX_METER_B:
			case BTN_TX_METER_C:
			case BTN_TX_METER_D:
			case BTN_TX_METER_E:
								 return false;
								 break;
			default: return true;
		}
	}
	else	
	{
		return false;	 
	}
}



function onPwcClick(btnno)
{
	if(buttonTxBlock(btnno)) return;
	BlockButtonSync = true;
	clearTimeout(ButtonBlockTimeout);
	ButtonBlockTimeout = setTimeout(unblockButtonSync, 3000);
	
	if((btnno == BTN_VFOA) && (VfoRx == 'B') && (btnVfoAinactive == false))
	{
		SetAudioAB(); 
		setVFO('A');
		changedVFO = true;
	}
	if((btnno == BTN_VFOB) && (VfoRx == 'A') && (btnVfoBinactive == false))
	{
		SetAudioAB(); 	
		setVFO('B');
		changedVFO = true;
	}
	if(btnno == BTN_SWAPAB)
	{
		SetAudioAB();
		if(VfoRx == 'A')
		{setVFO('B'); btnno = BTN_VFOB;}
		else
		{
			if(VfoRx == 'B'){setVFO('A'); btnno = BTN_VFOA;};
		}
		changedVFO = true;	
	}
	doButtonAction(btnno);
}


////////////////////////////////////////////////////////

function doButtonAction(btnno)
{
	blockFreqRead = false;
	var xindex;
	var xactive;
	var xid;
	var delta;
	var xvx;
	var modex; 
	var resetid;
	var xbtncolor;
	var xbtnno;
	var btndata;
	var bgsdata;
	var rw;
	var bx;
	var by;
	var f;
	var bon;
	// first collect buttons into from arrays
	var listIndex = getButtonListIndex(btnno);
	if(listIndex == 255) {return;};
	var id = ButtonList[listIndex][1];
	if(id == 'nobtn') return;	
  var arrayIndex = getButtonArrayIndex(btnno);
	if(arrayIndex == 255){ return;};
	var action = ButtonArray[arrayIndex]['action'];
	var active = ButtonArray[arrayIndex]['active'];
	if((active === 'L') || (active === 'N')) return; 
	var btncolor = ButtonArray[arrayIndex]['color'];
	var vx = ButtonArray[arrayIndex]['vx'];
	var xab = vx;
	if(vx == 'V'){xab = VfoRx;};
	var code = ButtonArray[arrayIndex]['code']; 
	// if in group (action = 'G') clear group
	if((action == 'G') || (action == 'M'))
	{

		if(catcomms == 'CIV')
		{
			btndata = ButtonArray[arrayIndex]['bgsdata'];
		}
		else
		{ 
			btndata = ButtonArray[arrayIndex]['nset']; 
		}
		if(btndata == 'xxx') return;


		for(var i in ButtonArray)
		{  
			if(((ButtonArray[i]['action'] == 'G') || (ButtonArray[i]['action'] == 'M')) 
			&& (ButtonArray[i]['code'] == code))
			{
				xactive = ButtonArray[i]['active'];
				xbtnno = ButtonArray[i]['btnno'];		
				xvx = ButtonArray[i]['vx'];
				xbtncolor = ButtonArray[i]['color'];		
				xindex = getButtonListIndex(xbtnno);
				xid = ButtonList[xindex][1];
				ButtonInactivate(xid, xactive, xbtncolor, i);
				setButtonVals(i,0,xvx);
			}	 
		}	
		ButtonActivate(id, arrayIndex);	
		setButtonVals(arrayIndex, 1, vx);
		
		// If band has to be specified by a frequency then data will be > 10000
		// So use last band frequency for this band if it is in the new band
		// (except first change when specified freq will be used)
		if((code == 'BAND') && (btndata > 10000))
		{
			bx = freqBand(btndata);

			if(bx < 14)
			{
				f = lastbandfreq[bx];
				by = freqBand(f);
				if(bx == by)
				{
					btndata = f;
					modex = lastbandmode[bx];
					if(modex != 'FF')
					{
						setTimeout(function(){queueWebcatMessage('BUTN', xab, CAT_WRITE, 'MODE', modex, true, 0);},1000);
					}			
				};
			}			
		}		
		if(action == 'G')
		{
			if(code == 'CWME'){lastCWME = btndata;};
			if(code == 'CWRP'){setCwRepeatInterval(btndata); return;};
			if((catcomms == 'HAMLIB') && (code == 'MODE'))
			{
				btndata = btndata + ' -1';		
			}
			queueWebcatMessage('BUTN', xab, CAT_WRITE, code, btndata, true, 0);	// band change freq written here
			return;	
		}
		else   /// action == 'M'
		{
			TXMbtnno = btnno;
		}
	}
	// toggling button	
	if(action == 'T')    
	{
		if(ButtonList[listIndex][2] == 0)
		{
			ButtonList[listIndex][2]  = 1;
			ButtonActivate(id, arrayIndex);		
			if(code == 'SPLT') {split = true;};
			setButtonVals(arrayIndex, 1, vx);
			if(catcomms == 'CIV')
			{
				btndata = ButtonArray[arrayIndex]['von'];			
			}
			else
			{
				btndata = ButtonArray[arrayIndex]['seton'];
			} 
			btncolor = ButtonArray[arrayIndex]['color'];
			queueWebcatMessage('BUTN', xab, CAT_WRITE, code, btndata, true, 0);		
		} 
		else
		{
			ButtonList[listIndex][2]  = 0;
			ButtonInactivate(id, active, btncolor, arrayIndex);		
			if(code == 'SPLT') {split = false;};
			setButtonVals(arrayIndex, 0, vx);
			if(catcomms == 'CIV')
			{
				btndata = ButtonArray[arrayIndex]['voff'];			
			}
			else
			{
				btndata = ButtonArray[arrayIndex]['setoff'];
			}  
			queueWebcatMessage('BUTN', xab, CAT_WRITE, code, btndata, true, 0);				
		}
		if(code == 'RPGO')
		{
			cwMessageRepeater(btndata);
			return;
		};
		if(VfoRx == 'A') ButtonArray[arrayIndex]['aval'] = btndata;
		if(VfoRx == 'B') SliderArray[arrayIndex]['bval'] = btndata;								
	}
		// slider reset buttons - to default valuse which is CAT value
	if(action == 'R')
	{
		resetid = getResetListId(btnno);
		ButtonActivate(resetid, arrayIndex);
		sliderResetButton(listIndex);	
		setTimeout(RestoreResetButton, 200, resetid);
	}
	if(action == 'S')
	{
		ButtonActivate(id, arrayIndex);
		setTimeout(ButtonInactivate, 150, id, 'Y', btncolor, arrayIndex);
		if(catcomms == 'CIV')
		{
			btndata = ButtonArray[arrayIndex]['von'];			
		}
		else
		{
			btndata = ButtonArray[arrayIndex]['seton'];
		} 
		delta = parseInt(btndata);
		switch(code)
		{
			case 'DBUG':
			{
				divToggle('popDebug',1);
				return;	
			}
			case 'MORE':
			{
				divToggle('popMoreButtons',1);
				moreShowing = true;
				return;	
			}
			case 'MPAD':
			{
				startMempad(); 
				return;
			}
			case 'MECH':
			{
				queueWebcatMessage('BUTN', xab, CAT_WRITE, 'MPAD', btndata, true, 0);
				$("#MemIndicator").text("M:" + btndata.toString());		
				blockMemClear = true;
				memFreq = 0;
				setTimeout(sendMTOV, 1000);
				setTimeout(function(){ blockMemClear = false; }, 3000);
				return;
			}
			case 'FRUP':
			{
				freqSet = delta*Math.floor(freqSet/delta) + delta;
				queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', freqset, true, 0);
				setFreqDisplayMain(freqSet);
				return;
			}	
			case 'FRDN':
			{
				freqSet = delta*Math.ceil(freqSet/delta) - delta ;
				queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', freqset, true, 0);
				setFreqDisplayMain(freqSet);
				return;
			}
			default:
			{
				// btndata irrelevent on FTdx101D because these are single action ommans, eg : SV;11
				queueWebcatMessage('BUTN', xab, CAT_WRITE, code, btndata, true, 0);
			}
		}				
	}
}	
	
	
	
/////////////////////////////////////////////////////////////////////////////////////



function getButtonSettings()
{
	var code;
	var action;
	var btno;
	var listIndex;
	var active;
	var vx;
	var getset;
	var prevcode = 'WXYZ';
	for(var i in ButtonArray)
	{
		code = ButtonArray[i]['code'];
		action = ButtonArray[i]['action'];
		active = ButtonArray[i]['active'];
		vx = ButtonArray[i]['vx'];
		if(catcomms == 'HAMLIB')
		{getset = ButtonArray[i]['getset'];}
		else
		{getset = 'G';};   // dummy G for non-HAMLIB
		if(code == '') {continue;};
		if((code == prevcode) && (action == 'G')) {continue;};  //.. only one of a group
		if((active == 'N') || (action == 'S') || (action == 'R') || (action == 'M')) {continue;};
		prevcode = code;
		if(vx == 'V') {vx = VfoRx;};
		if(getset.includes("G") == false){ continue;};
		sendWebcatMessage('BUTN', vx, CAT_READ, code, 0, false);
	}	
} 
 
//////////////////////////////////////

// separate queued message every ?1000sm to follow rig
function getMoxStatus()
{
	if(StopRepitasks) return;
	queueWebcatMessage('MOX', 'X', CAT_READ, 'MOX', 0, false, 0);	
}





//////////////////////////


