﻿// clientinit.js

"use strict";

// note that ButtonArray and SliderArray fields correspond to  MYSQL fields 
// from wcajaxinit.php

var ButtonArray		= [];
var SliderArray		= [];
var LookupArray		= [];
var TimingArray		= [];
var MeterArray 		= [];
var MeterCalArray = [];
var RadiosArray 	= [];
var SettingsArray = [];
var BandsArray		= [];
var SyncButtonsArray = [];
var SyncSlidersArray = [];

var catAnswerArray  = [];   // used by all ajax calls
														// must be defined globally other memory leak
var SyncButtonCount;
var SyncButtonIndex;

var SyncSliderCount;
var SyncSliderIndex;
var SyncButtonRead = true;

var BlockSliderSync = false;
var BlockButtonSync = false;

var StopRepitasks = true;

var sdata;
var rig = "xxxx";
var radioIndex;
var DisableRepitasks = false;
var cno;
var initResult = "OK";

var vfomode;
var rigfix;
var hamlib;
var connection;
var catcomms;
var civaddr;
var baudrate;
var parity;
var charbits;
var stopbits;
var vfobvis;
var afswap;
var mtov = 'Y';

var moxMs;
var syncMs;
var meterMs;
var freqcurMs;
var freqzzMs;
var modecurMs;
var modezzMs;
var chkbandMs;
var chksetfreqMs;
var readqueueMs;


var btnVfoAinactive = false;
var btnVfoBinactive = false;

var CurrentWindow = 'CONTROL';




function pwcInit()  // called on window load
{		
	queueInit();

	ButtonMessageEnable = true;
	ModeButtonMessageEnable = true;

	$("#btntest").hide();
	MessageBoxBig('Starting piWebCAT...', false);

	ajaxGetSettingsArray();		
	
	
	rig = SettingsArray[0]['rig'];
	
	var cno = SettingsArray[0]['cno'];
	var scno = cno.toString();
	$("#logContestNo").val(scno); 
	$("#captiontext").html(rig);

	ajaxGetRadiosArray();
	
	for(var i in RadiosArray)
	{
		if(RadiosArray[i]['rig'] == rig)
		{
			radioIndex = i;
			break;
		}
	}
	connection = RadiosArray[radioIndex]['connection'];
	catcomms = RadiosArray[radioIndex]['catcomms'];
	rigfix = RadiosArray[radioIndex]['rigfix'];
	baudrate = RadiosArray[radioIndex]['baudrate'];
	parity = RadiosArray[radioIndex]['parity'];
	charbits = RadiosArray[radioIndex]['charbits'];
	stopbits = RadiosArray[radioIndex]['stopbits'];		
	vfobvis = RadiosArray[radioIndex]['vfobvis'];
	afswap = RadiosArray[radioIndex]['afswap'];
	hamlib = RadiosArray[radioIndex]['hamlib'];
	civaddr = RadiosArray[radioIndex]['civaddr'];   // hamlib only
	vfomode = RadiosArray[radioIndex]['vfomode'];   // hamlib only
	
	if(vfobvis != 'Y')
	{
	 	$("#freqnosel").hide();
		$("#ModeRxNoSel").hide();
	}
	if(connection == 'ENCAT')
	{
		baudrate = 115200;
		charbits = 8;
		parity = 'none';
		stopbits = 1;
	}

	$("#serialfooter").html('CAT = ' + catcomms + '&nbsp;&nbsp;&nbsp; interface = ' + connection + '&nbsp;&nbsp;&nbsp; baud = ' + baudrate);	
	
	doSerialInit();  
	//ajaxSerialInit(baudrate, stopbits, charbits, parity, connection, catcomms, rigfix, hamlib, civaddr, vfomode);
	// also sets session variable for catcomms and connection	 

	if(initResult != "OK")
	{
		KillMessageBoxBig();
		MessageBoxBig("Failed to start rig data connection",true);
		return;
	}	
	
	ajaxGetButtonArray();	
	ajaxGetSyncButtonsArray();
	ajaxGetSyncSlidersArray();
	ajaxGetSliderArray();
	ajaxGetLookupArray();
	ajaxGetTimingArray();
	ajaxGetMeterArray();
	ajaxGetMeterCalArray();
	ajaxGetBandsArray();
		
	SyncButtonCount = SyncButtonsArray.length;  
	SyncButtonIndex = 0;  
	SyncSliderCount = SyncSlidersArray.length;
	SyncSliderIndex = 0;
	
	setBandLimits();

	setRadioOptions();

	setButtonCaptions();
	
	setSliderCaptions();

	StopRepitasks = false;

	getVfoAB();  // need VFO id before loading controls
			
	$("#radiolist").val(rig);  // set option selector

	moxMs = parseInt(TimingArray[0]['mox'], 10);
	syncMs = parseInt(TimingArray[0]['sync'], 10);
	meterMs = parseInt(TimingArray[0]['meter'], 10);
	freqcurMs = parseInt(TimingArray[0]['freqcur'], 10);   // freqcur ia active vof here
	freqzzMs = parseInt(TimingArray[0]['freqzz'], 10);
	modecurMs = parseInt(TimingArray[0]['modecur'], 10);   // freqzz is background vfo here
	modezzMs = parseInt(TimingArray[0]['modezz'], 10);
	chkbandMs = parseInt(TimingArray[0]['chkband'], 10);
	chksetfreqMs = parseInt(TimingArray[0]['chksetfreq'], 10);
	readqueueMs = parseInt(TimingArray[0]['readqueue'], 10);

	DisableRepitasks = (TimingArray[0]['disable'] == 'Y');
	if(readqueueMs > 0){setInterval(queueNext,readqueueMs);};	
	
	InitialiseMeterButtons();

	if(VfoRx == 'B')
	{
		doButtonAction(BTN_VFOB);
	}
	else
	{
		doButtonAction(BTN_VFOA);
	}
	
///////////
	//if(syncMs > 0){setInterval(getSyncControlsStatus, syncMs);};
//	if(moxMs > 0){setInterval(getMoxStatus, moxMs);};

	if(!DisableRepitasks)
	{
		if(moxMs > 0){setInterval(getMoxStatus, moxMs);};
		if(syncMs > 0){setInterval(getSyncControlsStatus, syncMs);};
		if(meterMs > 0){setInterval(smeterCAT, meterMs);};
		if(freqcurMs > 0){setInterval(getFreqCurCat, freqcurMs);};
		if((freqzzMs > 0) && (vfobvis == 'Y')){setInterval(getFreqZzCat, freqzzMs);};  // vfob is background VFO here, not VFOB
		if(chkbandMs > 0){setInterval(checkBandMain, chkbandMs);};
	  if(modecurMs > 0){setInterval(checkModeCur, modecurMs);};
	  if(modezzMs > 0){setInterval(checkModeZZ, modezzMs);};
	}
	if(chksetfreqMs > 0){setInterval(checkSetFreqMain, chksetfreqMs);};
/////////////
	
	startPwcTimers();	 // in pwctimers.js ... 500ms and 1 minute  - using Date.now()

	initTunerA();
	initRxTuner();	
	
	BlockSliderSync = false;
	BlockButtonSync = false;
}

//////////////////////////////////////////////////////

function checkModeCur()
{
	if(StopRepitasks) return;
	queueWebcatMessage('BUTN', VfoRx, CAT_READ, 'MODE', 0, true);	
}


function checkModeZZ()
{
	if(StopRepitasks) return;
	var vfo;
	if(VfoRx == 'A'){vfo = 'B';} else {vfo = 'A';};	
	queueWebcatMessage('BUTN', vfo, CAT_READ, 'MODE', 0, true, 0);	
}


function setRadioOptions()
{
	for(var i in RadiosArray)
	{   
		 $('#radiolist').append('<option value="' + RadiosArray[i]['rig'] + '">' + RadiosArray[i]['description'] + '</option>');
	}
}


//////////////////////////////////////////////////////////




function getSyncControlsStatus()   
{
	if(StopRepitasks) return;
	if(SyncButtonRead)
	{ 
		if(SyncButtonIndex >= SyncButtonCount)
		{		
			SyncButtonIndex = 0;
			if(SyncSliderCount > 0)			
			{
				SyncButtonRead = false;   // ie: slider read is true!
				getSyncSliderStatus();
				return;
			}	
		}
		getSyncButtonStatus();
	}
	else
	{
		if(SyncSliderIndex >= SyncSliderCount)
		{
			SyncSliderIndex = 0;
			if(SyncButtonCount > 0)
			{
				SyncButtonRead = true;
				getSyncButtonStatus()
				return;
			}	
		};	
		getSyncSliderStatus();
	}		
}



function getSyncButtonStatus()
{
	if(SyncButtonCount == 0) return;
	var code = SyncButtonsArray[SyncButtonIndex]['code'];
	var vx = SyncButtonsArray[SyncButtonIndex]['vx'];
	if(vx == 'V'){vx = VfoRx;};
	if(queueWebcatMessage('BUTN', vx, CAT_READ, code, 0, false, 0)){SyncButtonIndex++;};
}


function getSyncSliderStatus()
{
	if(SyncSliderCount == 0) return;
	var code = SyncSlidersArray[SyncSliderIndex]['code'];
	var vx = SyncSlidersArray[SyncSliderIndex]['vx'];
	if(vx == 'V'){vx = VfoRx;};
	if(queueWebcatMessage('SLDR', vx, CAT_READ, code, 0, false, 0)) {SyncSliderIndex++;};	
}

////////////////////////////////////////////////////


function RepitaskStarter()
{
//	setTimeout(function(){StopRepitasks = false; },7000);
}


function ChangeRadio()
{
	var selectedrig = $('#radiolist :selected').val();
	ajaxSetRadio(selectedrig);
}



// at startup tis is called by band change   .. DON NOT call it again separately!
function rigReload()
{
	StopRepitasks = true;
	RepitaskStarter();
	rigLoadSettings();
	displayBand(band);
}



function rigLoadSettings()
{
	$("#tableControls").find("input,button,textarea,select").prop("disabled", true);
	KillMessageBoxBig();
	MessageBoxBig('Loading band settings from radio...', false);
	getSliderSettings();
	getButtonSettings();
	StopRepitasks = false;
	KillMessageBoxBig();
	$("#tableControls").find("input,button,textarea,select").prop("disabled", false);

}




// get current default rig - from a single record table in MYSQL     
function ajaxSetRadio(selectedrig)
{
	var urlparams = 'rig=' + selectedrig;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcsetradio.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,
		  timeout: 500,  	           
		  success: function(data){document.getElementById('btnrefresh').click();},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;		
}


function doSerialInit()
{
	ajaxSerialInit(baudrate, stopbits, charbits, parity, connection, catcomms, rigfix, hamlib, civaddr, vfomode);
}

// civaddr parameter only for hamlib
function ajaxSerialInit(baudrate, stopbits, charbits, parity, connection, catcomms, rigfix, hamlib, civaddr, vfomode)
{	
	var urlparams = 'baudrate='  + baudrate + '&stopbits=' + stopbits + '&charbits=' + charbits + '&parity=' + parity
	    + '&connection=' +  connection + '&catcomms=' + catcomms + '&rigfix=' + rigfix + '&hamlib=' + hamlib
	    + '&civaddr=' + civaddr + '&vfomode=' + vfomode; 	
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxserialinit.php',            
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,    
		  success: function(data){initResult = "OK";},
		  timeout: 5000,  	  
		  error: function(data){initResult = "FAIL";}
		});
	ajaxreq = null;	
}




// get button data  array from server    
function ajaxGetButtonArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_BUTTONS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false, // wait until complete
		  timeout: 5000,  	            
		  success: function(data){ButtonArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;			
}




// get button data  array from server    
function ajaxGetSyncButtonsArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_SYNC_BUTTONS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false, // wait until complete
		  timeout: 5000,  	            
		  success: function(data){SyncButtonsArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;		
}




// get slider data  array from server    
function ajaxGetSliderArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_SLIDERS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,  
		  timeout: 5000,  	         
		  success: function(data){SliderArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}



// get slider data  array from server    
function ajaxGetSyncSlidersArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_SYNC_SLIDERS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,  
		  timeout: 5000,  	         
		  success: function(data){SyncSlidersArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}





// get lookup data  array from server    
function ajaxGetLookupArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_LOOKUPS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,
		  timeout: 5000,  	           
		  success: function(data){LookupArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}


// get current default rig - from a single record table in MYSQL     
function ajaxGetSettingsArray()
{
	var urlparams = 'rig='  + 'ALL' + '&job=' + GET_SETTINGS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,
		  timeout: 1000,  	           
		  success: function(data){SettingsArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;		
}




// get raadiooss data for repitasks etc   array from server    
function ajaxGetRadiosArray()
{
	var urlparams = 'rig='  + 'ALL' + '&job=' + GET_RADIOS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,
		  timeout: 3000,  	           
		  success: function(data){RadiosArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}




// get timing data for repitasks etc  array from server    
function ajaxGetTimingArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_TIMINGS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false, 
		  timeout: 3000,  	          
		  success: function(data){TimingArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}


// get meter data for repitasks etc  array from server    
function ajaxGetMeterArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_METER;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,  
		  timeout: 2000,         
		  success: function(data){MeterArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}



// get meter calibration data for repitasks etc   array from server    
function ajaxGetMeterCalArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_METER_CAL;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,    
		  timeout: 2000,    
		  success: function(data){MeterCalArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;		
}


// get meter calibration data for repitasks etc   array from server    
function ajaxGetBandsArray()
{
	var urlparams = 'rig=' + rig + '&job=' + GET_BANDS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,    
		  timeout: 2000,    
		  success: function(data){BandsArray = catParseJSON(data, false);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}


function inactivateResetButton(btnno)
{
	var i;
	var id;
	for(i=0;i<ResetButtonsList.length;i++)
	{
		if(ResetButtonsList[i][0] == btnno) 
		{
			id = ResetButtonsList[i][1];
			$("#" + id).css("background-color", "silver");
			$("#" + id).css("color","gray");
			$("#" + id).attr('disabled', true);
			$("#" + id).css("border","silver"); 
			$("#" + id).val(""); 
			return;
		}	
	}	
}




function setButtonCaptions()
{
	var i;
	var cap;
	var id;
	var btncolor;
	var active;
	var listIndex;
	var action;
	var btnno;

	for(var i in ButtonArray)
	{		
		cap = ButtonArray[i]['caption'];	
		active = ButtonArray[i]['active'];
		btncolor = ButtonArray[i]['color'];
		action = ButtonArray[i]['action'];
		btnno = ButtonArray[i]['btnno'];
		if((btnno == BTN_VFOA) && (active == 'N')){btnVfoAinactive = true;};
		if((btnno == BTN_VFOB) && (active == 'N')){btnVfoBinactive = true;};		
		listIndex = getButtonListIndex(btnno);
		if(listIndex == 255) {continue;};
		id = ButtonList[listIndex][1];
		if(id.substring(0,6) == "slider")
		{		
			if(active == 'N'){inactivateResetButton(btnno);};	
			continue;
		}
		id = "#" + id;
		$(id).val(cap);
		
		if(active == 'L')
		{
      $(id).removeClass().addClass("buttonsync");       
		}
		else
		{
			$(id).css("background-color", btncolor);
		}
		if(active == 'N') 
		{
			$(id).css("background-color", "silver");
			$(id).css("color","gray");
			$(id).attr('disabled', true);
			$(id).css("border","silver"); 
			$(id).val("....");
		}
	}
	for(var i in MeterArray)
	{		
		cap = MeterArray[i]['caption'];	
		listIndex = getButtonListIndex(MeterArray[i]['btnno']);
		if(listIndex == 255) {continue;};
		id = ButtonList[listIndex][1];
		id = "#" + id;
		$(id).val(cap);
	}
	
}





function setSliderCaptions()
{
	var i;
	var cap;
	var capid;
	var active;
	var color;
	var sliderno;
	var textid;
	var id;
	var listIndex;
	var listIndexPrevious = 254;	
	for(var i in SliderArray)
	{	
		cap = SliderArray[i]['caption'];
		active = SliderArray[i]['active'];
		color = SliderArray[i]['color'];
		listIndex = getSliderListIndexFromSliderno(SliderArray[i]['sliderno']);
		if(listIndex == 255) {continue;};
		if(listIndex == listIndexPrevious) {continue;};  // some sliders have multiple entries
		listIndexPrevious = listIndex;
		sliderno = SliderList[listIndex][0];
		id = SliderList[listIndex][1];   // id of slider
		textid = SliderList[listIndex][2];   // id of associated data
		capid = SliderList[listIndex][3];    // id of caption (or "nocap" if there is node (button instead) 
		if(capid != "nocap"){	$("#" + capid).text(cap);}
	
		if((active == 'N') && (sliderno < 51))
		{
			$("#" + capid).hide();//css('color','silver');
			$("#" + textid).hide();
			$("#" + id).removeClass("slider");
			$("#" + id).addClass("sliderxx");
			$("#" + id).slider({disabled: true});
			$("#" + id).css("background-color", "silver");				
		}
		else
		{
			$("#" + id).css('background',color);			
		}
		if(active == 'L')
		{
     	$("#" + id).removeClass().addClass("slidersync");     	     
			$("#" + id).css('background','teal');
			$("#" + id).attr('disabled','disabled');
		}
	}

}


