﻿// configinit.js

"use strict";

// note that ButtonArray and SliderArray fields correspond to  MYSQL fields 
// from wcajaxinit.php

var RadiosArray 	= [];
var SettingsArray    = [];


var sdata;
var rig = "xxxx";
var radioIndex;

var catcomms;

var CurrentWindow = 'CONFIG';  // applies also to metercal

function configInit()  // called on window load
{			

	ajaxGetSettingsArray();		
	rig = SettingsArray[0]['rig'];
	
	$("#captiontext").html(rig);

	
	ajaxGetRadiosArray();
	for(var i in RadiosArray)
	{
		if(RadiosArray[i]['rig'] == rig)
		{
			radioIndex = i;
			break;
		}
	}
	catcomms = RadiosArray[radioIndex]['catcomms'];	
	
	setRadioOptions();
	
	$("#radiolist").val(rig);  // set option selector	
}
 


function setRadioOptions()
{
	for(var i in RadiosArray)
	{   
		 $('#radiolist').append('<option value="' + RadiosArray[i]['rig'] + '">' + RadiosArray[i]['description'] + '</option>');
	}
}



function ChangeRadio()
{
	var selectedrig = $('#radiolist :selected').val();
	ajaxSetRadio(selectedrig);
}




function setTableButtons()
{
	if(catcomms == 'CIV')
	{
		$("#btnButtons").val("buttonssciv");
		$("#btnCatcodes").val("catcodesciv");
		$("#btnSliders").val("slidersciv");
		$("#btnMeter").val("meterciv");
		return;
	}
	if((catcomms == 'ASCII') || (catcomms == 'YAESU5'))
	{
		$("#btnButtons").val("buttons");
		$("#btnCatcodes").val("catcodes");
		$("#btnSliders").val("sliders");
		$("#btnMeter").val("meter");
		return;
	}	
	if(catcomms == 'HAMLIB')
	{
		$("#btnButtons").val("buttonsshl");
		$("#btnCatcodes").val("catcodeshl");
		$("#btnSliders").val("slidershl");
		$("#btnMeter").val("meterhl");
		return;
	}	
}





// get current default rig - from a single record table in MYSQL     
function ajaxSetRadio(selectedrig)
{
	var urlparams = 'rig=' + selectedrig;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcsetradio.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,         
		  success: function(data){document.getElementById('btnrefresh').click();},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;		
}




// get current default rig - from a single record table in MYSQL     
function ajaxGetSettingsArray()
{
	var urlparams = 'rig='  + 'ALL' + '&job=' + GET_SETTINGS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,         
		  success: function(data){SettingsArray = $.parseJSON(data);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;			
}


// get raadiooss data for repitasks etc   array from server    
function ajaxGetRadiosArray()
{
	var urlparams = 'rig='  + 'ALL' + '&job=' + GET_RADIOS;
	var ajaxreq =
		$.ajax({                                      
			type: 'POST',
			url: 'cat/phpfiles/wcajaxinit.php',        
		  data: urlparams,
		  dataType: 'text',
		  cache: false,   
		  async: false,         
		  success: function(data){RadiosArray = $.parseJSON(data);},
		  error: function(data){console.log('error');}
		});
	ajaxreq = null;	
}





