﻿// piWebCAT  Javascript smeter, power meter etc

//"use strict";

var neepos =
[
	[ 44,   4,  45],  //  0:  S0
	[ 57,  17,  37],
	[ 66,  30,  31],
	[ 75,  45,  26],  //  3:  S3
	[ 86,  59,  22],
	[ 94,  74,  19],
	[102,  84,  17],  //  6:  S6
	[110,  99,  16],
	[117, 111,  15],
	[125, 125,  14],  //  9:  S9
	[133, 138,  14],
	[142, 152,  15],
	[148, 164,  16],  // 12:  +20
	[157, 178,  17],
	[165, 192,  22],
	[173, 205,  26],  // 15:  +40
	[182, 219,  32],
	[194, 231,  39],
	[204, 245,  46]   // 18:    +60
];	
	
	
var mm = 0;
var catAnswerArray = [];

var TXMbtnno; // startup default (this is NOT a

var MeterMult;
var MeterDivide;
var MeterUseCal;
var MeterOffset;

var prevmval = 0;

var meterCounter = 0;
var meterRate = 0;



function drawNeedle(mval)
{
	if(mval < 1) mval = 1;
	if(mval > 255) mval = 255;
	
	if(prevmval > mval)     /// meter needle damping
	{
		if(mval < (prevmval - 30)) 
		{mval = prevmval -20;}
		else
		{
			if(mval < (prevmval - 20))
			{mval = prevmval - 13;}
			else
			{
				if(mval < (prevmval - 10))
				{mval = prevmval - 7;}
				else
				{
					if(mval < (prevmval - 5))
				  {mval = prevmval - 3;}
				}  
			}
		}		
	}
	else
	{
		if(mval > prevmval*1.2){mval = (mval + prevmval)/2;}
	}
	prevmval = mval;	
	
	var z = (mval*18)/256;
	var i = Math.floor(z);
	var d = z - i;
	///////////
	var x = neepos[i][0];
	var dx = neepos[i+1][0] - x;
	var x1 = x + dx*d;	
	///////////
	x = neepos[i][1];
	dx = neepos[i+1][1] - x;
	var x2 = x + dx*d;
	///////////
	var y = neepos[i][2];
	var dy = neepos[i+1][2] - y;
	var y2 = y + dy*d;  // dy may be negative   - which is ok
	////////////
	x1 = Math.floor(x1 + 0.5);
	x2 = Math.floor(x2 + 0.5);
	var y1 = 120;
	y2 = Math.floor(y2 + 0.5);
	///////////////	    -11 is correction for having moved the meter upwards 11 pixels !!
	$('#meterboxmain').line(x1, y1-11, x2, y2-11,  {stroke:3, color:"red"});
}

///////////////////////////////////////////



function smeterCAT()
{
	if(StopRepitasks) return;
	var arrayIndex;
	var xcode = 'xxxx';
	if(Transmitting == false)
	{
		if(VfoRx == 'A') {xcode = 'SMTA';} else {xcode = 'SMTB';};
	}
	for(var i in MeterArray)
	{
		if(Transmitting) 
		{
			if(MeterArray[i]['btnno'] == TXMbtnno)
			{
				xcode = MeterArray[i]['code'];
				arrayIndex = i;
				break;
			}
		}
		else
		{		
			if(MeterArray[i]['code'] == xcode)
			{
				arrayIndex = i
				break;
			}			
		}
	}		
	MeterMult = parseFloat(MeterArray[i]['mult']);
	MeterDivide = parseFloat(MeterArray[i]['divide']);
	MeterOffset = parseFloat(MeterArray[i]['offset']);
	MeterUseCal = MeterArray[i]['usecal'];
	queueWebcatMessage('METR', VfoRx, CAT_READ, xcode, 0, true, 0);	
}	



function getMeterCal(v, meter)
{
	var outvals = [];
	var invals = [];
	var max;
	var inval;
	var outval;
	var seq;
	var vcal = 0;
	//for(var i in MeterCalArray)
	len = MeterCalArray.length;
	var i;
	for(i=0;i<len;i++)
	{  	
		if(MeterCalArray[i]['meter'] == meter)
		{
			seq = parseInt(MeterCalArray[i]['seq'], 10);
			inval = parseInt(MeterCalArray[i]['inval'], 10);
			outval = parseInt(MeterCalArray[i]['outval'], 10);
			if(seq > 0)
			{
				outvals[seq] = outval;
				invals[seq] = inval;
			}
			else
			{
				max = parseInt(MeterCalArray[i-1]['seq'], 10);			
				break;
			};
		}
	}

	for(i=1;i<max;i++)
	{
		if(v == invals[i])
		{
			vcal = outvals[i];
			break; 
		}
		
		if((v > invals[i]) && (v <= invals[i+1]))
		{
			vcal =   outvals[i] +  ( ( (v - invals[i])*(outvals[i+1] - outvals[i])  ) /(invals[i+1] - invals[i]));
			break;
		}
	}	
	return Math.floor(vcal);
}



function getMeterLevelCallback()
{
	meterCounter++;
	var v = Math.floor((catAnswerArray["value"]*MeterMult) / MeterDivide) + MeterOffset;
	$("#metercat").text('Meter CAT scaled = ' + v);  // cal value on apge footer

	if(Transmitting)
	{	 
		switch(TXMbtnno)
		{
			case BTN_TX_METER_A:
				$('#meterboxmain').html('<img src="/cat/images/TXmeterA.bmp" />');
				if(MeterUseCal == 'Y') { v = getMeterCal(v, 'TA');};			
				break;
			case BTN_TX_METER_B:
				$('#meterboxmain').html('<img src="/cat/images/TXmeterB.bmp" />');
				if(MeterUseCal == 'Y') { v = getMeterCal(v, 'TB');};		
				break;
			case BTN_TX_METER_C:
				$('#meterboxmain').html('<img src="/cat/images/TXmeterC.bmp" />');
				if(MeterUseCal == 'Y') { v = getMeterCal(v, 'TC');};			
				break;
			case BTN_TX_METER_D:
				$('#meterboxmain').html('<img src="/cat/images/TXmeterD.bmp" />');
				if(MeterUseCal == 'Y') { v = getMeterCal(v, 'TD');};		
				break;
			case BTN_TX_METER_E:
				$('#meterboxmain').html('<img src="/cat/images/TXmeterE.bmp" />');
				if(MeterUseCal == 'Y') { v = getMeterCal(v, 'TE');};		
				break;
		}
	}
	else			
	{
		$('#meterboxmain').html('<img src="/cat/images/smeter.bmp" />');
		if(MeterUseCal == 'Y') { v = getMeterCal(v, 'SM');};		
	}		
	drawNeedle(v);
}
	


					

