﻿
var mouseX = 50;
var mouseY = 50;	

var wheelF = 500;
var wheelM = 100;
var wheelS = 20;
var dragF = 100;
var dragM = 20;
var dragS = 5;

var firstMove = false;
	
var downX = 0;	
var freqDown = 0;

var blockFreqRead = false;

var mouseDown = false;

var tunerLeft = 0;
var tunerRight = 0;
var tunerTop = 0;
var tunerBottom = 0; 

var prevyband = 0;

var TimeoutHandle;


function initTunerA()		
{

	pwctopLeft =  Math.round($("#pwctop")[0].getBoundingClientRect().left) + 6;  
	pwctopTop =  Math.round($("#pwctop")[0].getBoundingClientRect().top) + 6;
	pwctopRight =  Math.round($("#pwctop")[0].getBoundingClientRect().right) - 6;
	pwctopBottom =  Math.round($("#pwctop")[0].getBoundingClientRect().bottom) - 6;


	tunerLeft =  Math.round($("#tuneA")[0].getBoundingClientRect().left) + 6;  
	tunerTop =  Math.round($("#tuneA")[0].getBoundingClientRect().top) + 6;
	tunerRight =  Math.round($("#tuneA")[0].getBoundingClientRect().right) - 6;
	tunerBottom =  Math.round($("#tuneA")[0].getBoundingClientRect().bottom) - 6;
	////
	wheelF = SettingsArray[0]['mwF'];
	wheelM = SettingsArray[0]['mwM'];
	wheelS = SettingsArray[0]['mwS'];
	dragF = SettingsArray[0]['mdF'];
	dragM = SettingsArray[0]['mdM'];
	dragS = SettingsArray[0]['mdS'];
}



	document.addEventListener('mousemove', mouseMoved)
	
	$(window).mousewheel(function(turn, delta) {
		var step;
		var yband;
		if((mouseY > 246) || (mouseX > 1021)) return;
		step = 0;			
		yband = Math.floor((mouseY - tunerTop)/30);
		if(yband > 2) {yband = 2;}
		switch(yband)
		{
	  	case 0: step = wheelS; break;
	  	case 1: step = wheelM; break;
	  	case 2: step = wheelF; break;
	 		default: step = wheelM;
	 		0; break;
		}  
		var ff = freqSet - delta*step;
		freqSet = ff - (ff % step);
		blockFreqRead = true;
		setFreqDisplayMain(freqSet);
		freqMain = freqSet;   
		var jobdata = freqSet.toString(10);
		queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', jobdata, true, 0);
		$("#MemIndicator").text("");	
	})
	

	function mouseInPwcTop()
	{
		if(mouseY > pwctopBottom) return false;
		if(mouseX < pwctopLeft) return false;
		if(mouseX > pwctopRight) return false;
		if(mouseY < pwctopTop) return false;
		return true;
	}
	

	function mouseInTunerA()
	{
		if(mouseDown == false) return false;
		if(mouseY > tunerBottom) return false;
		if(mouseX < tunerLeft) return false;
		if(mouseX > tunerRight) return false;
		if(mouseY < tunerTop) return false;
		return true;
	}

	
	function mouseMoved(e) 
	{
 		$("#mousepos").text('X = ' + e.clientX + '    Y = ' + e.clientY);
  	mouseX = e.clientX;
 		mouseY = e.clientY;
		e.preventDefault(); 		
		if(!mouseInTunerA())
		{
			mouseDown = false;
			firstMove = true;
			return;
		}			
		if(!mouseDown) return;
		if(firstMove) {downX = mouseX - tunerLeft;};
		firstMove = false;
		dragFreq(mouseX - tunerLeft, mouseY - tunerTop);		
	}	
	


		 
function onTunerMouseOverA()
{
	freqSet = freqMain;
}


function onTunerMouseOutA()
{
	// mouse out occurs on changing lane ...fast med slow
	// we only want this action if leaving the uner area
	if(!mouseInTunerA())
	{
		freqMain = freqSet;
		mouseDown = false;
		firstMOve = true;
	}	
	startClearBlockFreqReadTimer();
}


function onTunerMouseDownA()
{
	clearTimeout(TimeoutHandle);
	freqDown = freqSet;
	freqMain = freqSet;
	mouseDown = true;	
	firstMove = true;
	blockFreqRead = true;
}	
		 
		 
function onTunerMouseUpA()
{
	freqMain = freqSet;
	mouseDown = false;
	firstMove = true;
	TimeoutHandle = setTimeout(clearBlockFreqRead, 500);
}	
		

// block Freqread prevents frequnecy display bounce on fast swipes
// particularly on android.
//piWebCAT's frequency display updates to the new swiped frequency immeditely
// the radio follows fairly quickly .. but sometimes not fast enough to avaoid
// the next frequency read form momentatarlt putting te display back to an earlier value
// The is quickly corrected by the next read - but doesn't look good.

function clearBlockFreqRead()
{ 
	blockFreqRead = false;
}
 

function startClearBlockFreqReadTimer()
{
	TimeoutHandle = setTimeout(clearBlockFreqRead, 700);
}



function dragFreq(mX, mY)
{
	var pixelstep = 0;
	var yband = Math.floor(mY/29);
	if(yband != prevyband)
	{
		downX = mX;
		freqDown = freqSet;
		prevyband = yband;
//		return;
	}
	if(yband > 2) {yband = 2;}
	switch(yband)
	{
	  case 0: pixelstep = dragS; break;
	  case 1: pixelstep = dragM; break;
	  case 2: pixelstep = dragF; break;
	}
	var ff = Math.round(freqDown + pixelstep*(mX - downX)); 
	freqSet = ff - (ff % pixelstep);
	setFreqDisplayMain(freqSet);
	freqMain = freqSet;
	var jobdata = freqSet.toString(10);
	queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', jobdata, true, 0);
	$("#MemIndicator").text("");	
} 



function checkSetFreqMain()
{
	if(StopRepitasks) return;
	if(!freqSetValid) return;
	if(freqMain != freqSet)
  {
  	freqMain = freqSet;
		var jobdata = freqSet.toString(10);
		queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', jobdata, true, 0);
		$("#MemIndicator").text("");			
	}
}



function setFreqCallback(data)
{
	err = 0;
	try{ catAnswerArray = JSON.parse(data);}
  catch(e)
  { 
  	err = DATA_ERROR_IN_PHP_CODE;
  	if(e instanceof SyntaxError) 
  	{ if(data.indexOf('Maximum execution') >= 0){ err = DATA_ERROR_PHP_TIMEOUT; }	}
  }	
	if(err==0){err = catAnswerArray.error;}
  if(err != 0) { return; }
  var f = catAnswerArray["value"];
}
	
