﻿"use strict";

const SLIDER_001 			= 1;
const SLIDER_002		  = 2;
const SLIDER_003		  = 3;
const SLIDER_004		  = 4;
const SLIDER_AF_GAIN 	= 5;
const SLIDER_006		  = 6; 

const SLIDER_IF_WIDTH	= 7;
const SLIDER_008		= 8;
const SLIDER_009 		= 9;
const SLIDER_010		= 10;
const SLIDER_011    = 11;
const SLIDER_012    = 12;


const SLIDER_018		= 18;
const SLIDER_019		= 19;
const SLIDER_020  	= 20;
const SLIDER_021		= 21;
const SLIDER_022		= 22;
const SLIDER_023    = 23;
const SLIDER_024    = 24;
const SLIDER_025		= 25;
const SLIDER_026		= 26;
const SLIDER_027    = 27;

const SLIDER_029    = 29;
const SLIDER_030    = 30;
const SLIDER_038    = 38;

const TEXTBOX_A = 51;
const TEXTBOX_B = 52;
const TEXTBOX_C = 53;
const TEXTBOX_D = 54;




/////////////////////////////////////////////////////
/*
   sliderList   fields:
[0] sliderno as used in onSliderChange(sliderno)
[1] id of slider for jQuery access as $("#sliderComp"). ..,. etc
[2] id of data text to right of slider
[3] id of caption to left of slider (or "nocap" where the identifier is the on/off button)
*/

var SliderList = [
	
  [SLIDER_001,			"slider001",			"text001",		"nocap"],
  [SLIDER_002,	 		"slider002",			"text002",		"cap002"],
  [SLIDER_003,	 		"slider003",			"text003",		"nocap"],
  [SLIDER_004,	 		"slider004",			"text004",		"cap004"],
  [SLIDER_AF_GAIN,	"sliderAfGain",		"textAfGain",	"capAfGain"],
  [SLIDER_006,	 		"slider006",			"text006",		"cap006"], 

  [SLIDER_IF_WIDTH,	"sliderIfWidth",	"textIfWidth",	"capIfWidth"],
  [SLIDER_008,		  "slider008",			"text008",			"cap008"],
  [SLIDER_009,		  "slider009",			"text009",			"cap009"],
  [SLIDER_010,	  	"slider010",			"text010",			"cap010"],
  [SLIDER_011,	 	  "slider011",	  	"text011",			"cap011"],
  [SLIDER_012,	    "slider012",			"text012",			"cap012"],


  [SLIDER_018,		"slider018",		"text018",		"nocap"],
  [SLIDER_019,		"slider019",		"text019",		"nocap"],
  [SLIDER_020,		"slider020", 		"text020",		"nocap"],
  [SLIDER_021,		"slider021",		"text021",		"nocap"],
  [SLIDER_022,		"slider022",		"text022",		"nocap"],


  [SLIDER_029,	"slider029",		"text029",		"cap029"],
  [SLIDER_030,	"slider030",		"text030",		"cap030"],
  [SLIDER_023,	"slider023",		"text023",		"nocap"],
  [SLIDER_024,	"slider024",		"text024",		"nocap"],
  [SLIDER_025,	"slider025",		"text025",		"nocap"],
	[SLIDER_026, 	"slider026",		"text026",		"nocap"],
	[SLIDER_027, 	"slider027",		"text027",		"cap027"],
	[SLIDER_038, 	"slider038",		"text038",		"cap038"],
	
	[TEXTBOX_A,  "unused", "textboxA", "textcapA"],
	[TEXTBOX_B,  "unused", "textboxB", "textcapB"],
	[TEXTBOX_C,  "unused", "textboxC", "textcapC"],
	[TEXTBOX_D,  "unused", "textboxD", "textcapD"]

];
		

var AudioPosA = 120;
var AudioPosB = 120;

var SliderBlockTimeout;

/////////////////////////////////////////////

function displayWidthTextbox(code, value)
{
 	var arrayIndex = getSliderArrayIndexFromCode(code);
 	if(arrayIndex == 255) return;
 	var sliderno = SliderArray[arrayIndex]['sliderno'];
 	var units = SliderArray[arrayIndex]['units'];
 	var color = SliderArray[arrayIndex]['color'];
 	var listIndex = getSliderListIndexFromSliderno(sliderno);
	if(listIndex == 255) {return;};
	var textid = SliderList[listIndex][2];		
	$("#" + textid).css("color", color);	
	$("#" + textid).text(value + " " + units);

}



function resetSliders()
{
	var code;
	var abx;
	var active;
	var vx;
	var sliderno;
	var listindex;
	var textid;
	var sliderid;
	var pos;
	var cat = 0;
	for(var i in SliderArray)
	{
		active = SliderArray[i]['active'];
		if(active == 'W') continue;
		vx = SliderArray[i]['vx'];
		if(vx != 'V') {continue;}	
		code = SliderArray[i]['code'];
		if((code == '') || (active == 'N')) {continue;};
		if(VfoRx == 'A') {cat = SliderArray[i]['aval'];};
		if(VfoRx == 'B') {cat = SliderArray[i]['bval'];};	
 		sliderno = SliderArray[i]['sliderno'];
 		listIndex = getSliderListIndexFromSliderno(sliderno);
		if(listIndex == 255) {continue;};
		textid = SliderList[listIndex][2];		
		sliderid = SliderList[listIndex][1];
		pos = catToPos(cat, i);
		$("#" + sliderid).val(pos); 
		$("#" + textid).text(catToText(cat, i));
	}	
	queueWebcatMessage('SLDR', 'A', CAT_READ, 'PWRF', 0, true, 0);  // A or B is ok
}

///////////////////////////////////////////////


function getSliderCatCallback()
{
  var cat = catAnswerArray["value"];
  var code = catAnswerArray["code"];
  var rxab = catAnswerArray["rxab"];
  drawSlider(cat, code, rxab);
}  
  
  
 
function drawSlider(cat, code, rxab)
{ 
	var arrayIndex = getSliderArrayIndexFromCode(code);
  var rawcat = cat;
  
  var SA = SliderArray;
  
  var active = SA[arrayIndex]['active'];
	var color = SA[arrayIndex]['color'];
 	if((active != 'Y') && BlockSliderSync) return;
 	if(arrayIndex == 255) {return;};
	if((rxab == 'A') || (rxab == 'B'))
	{
		if(VfoRx == 'A') {SA[arrayIndex]['aval'] = cat;};
		if(VfoRx == 'B') {SA[arrayIndex]['bval'] = cat;};
	}
 	var sliderno = SA[arrayIndex]['sliderno'];
 	var listIndex = getSliderListIndexFromSliderno(sliderno);
	if(listIndex == 255) {return;};
	var textid = SliderList[listIndex][2];		
	var sliderid = SliderList[listIndex][1];
	var pos = catToPos(cat, arrayIndex);
	
	if(active == 'T'){	$("#" + textid).css("color",color);};
	$("#" + sliderid).val(pos); 
	$("#" + textid).text(catToText(cat, arrayIndex));
	$("#" + textid).attr("title",rawcat);
}




function setSliderCatCallback()  // timing - this callback from server  - not radio!!
{
}


function getPWRF()
{
	var arrayIndex = getSliderArrayIndexFromCode('PWRF');
	var sliderno = SliderArray[arrayIndex]['sliderno'];
	var listIndex = getSliderListIndexFromSliderno(sliderno);
	var pwrfid = SliderList[listIndex][2];
	return $("#" + pwrfid).text();
}	
	


//////////////////////////////////////////////////////

	
function getSliderArrayIndexFromSliderno(sliderno)  // n is btnno 		
{
	for(var i in SliderArray)
	{
		if(sliderno == SliderArray[i]['sliderno']) {return i;};
	}	
	return 255;
}
	
	
function getSliderArrayIndexFromCode(code) 		
{	
	for(var i in SliderArray)
	{
		if(code == SliderArray[i]['code']) {return i;};
	}	
	return 255;
}
	

	
function getSliderListIndexFromSliderno(sliderno)
{
	var i;
	for(i=0;i<SliderList.length;i++)
	{
		if(SliderList[i][0] == sliderno) {return i;};
	}
	return 255;
}

function getSliderNoFromId(sliderid)
{
	var i;
	for(i=0;i<SliderList.length;i++)
	{
		if(SliderList[i][1] == sliderid) {return SliderList[i][0];};
	}
	return 255;
}
		
////////////////////////////////////////////////////

function getLookupValue(code, mode, catvalue)
{
	var mmode = mode;
	for(var i in LookupArray)
	{
		if((LookupArray[i]['code'] == code)
		&& ((LookupArray[i]['mode'] == mmode) || (LookupArray[i]['mode'] == 'X'))
		&& (LookupArray[i]['catvalue'] == catvalue))
		{return LookupArray[i]['lookup'];}
	}	
	// failed - probaly due to moded not in  table .. .for IF shift
	// so use LSB and try again
	mmode = 'LSB';
	for(var i in LookupArray)
	{
		if((LookupArray[i]['code'] == code)
		&& (LookupArray[i]['mode'] == mmode)
		&& (LookupArray[i]['catvalue'] == catvalue))
		{return LookupArray[i]['lookup'];}
	}		
	return 111;
}


function posToCat(pos, arrayIndex)
{
	var min = parseFloat(SliderArray[arrayIndex]['min'], 10);
	var max = parseFloat(SliderArray[arrayIndex]['max'], 10);
  var cat = (pos*(max - min))/400 + min;                  //*************************
  if(catcomms != 'HAMLIB'){cat = Math.floor(cat);};
	return cat;
}



function catToPos(cat, arrayIndex)
{
	var min = parseFloat(SliderArray[arrayIndex]['min'], 10);
	var max = parseFloat(SliderArray[arrayIndex]['max'], 10);
  return Math.floor(  400*(cat - min)/(max - min) );     //*********************
}


function catToText(cat, arrayIndex)
{
	var mult   		= parseInt(SliderArray[arrayIndex]['mult'], 10);
	var divide		= parseInt(SliderArray[arrayIndex]['divide'], 10);
	var offset		= parseInt(SliderArray[arrayIndex]['offset'], 10);
	var units			= SliderArray[arrayIndex]['units'];
	var lookup 		= SliderArray[arrayIndex]['lookup'];
	var decpoint	= parseInt(SliderArray[arrayIndex]['decpoint'], 10);
	var code 			= SliderArray[arrayIndex]['code'];
	var cval = cat;
	var Mode = 'Y';
	if((lookup == 'Y') || (lookup == 'M'))
	{
		if(lookup == 'M') {Mode = CurrentMode;};
		cval = getLookupValue(code, Mode, cat);
	}
	var v = (cval*mult)/divide;
	v =  v / Math.pow(10, decpoint) + offset;
  v = v.toFixed(decpoint);
	return  v + " " + units;
}


function posToText(pos, arrayIndex)
{
	var min 			= parseInt(SliderArray[arrayIndex]['min'], 10);;
	var max 			= parseInt(SliderArray[arrayIndex]['max'], 10);
	var def 			= SliderArray[arrayIndex]['def'];
	var mult   		= parseInt(SliderArray[arrayIndex]['mult'], 10);
	var divide		= parseInt(SliderArray[arrayIndex]['divide'], 10);
	var offset		= parseInt(SliderArray[arrayIndex]['offset'], 10);
	var units			= SliderArray[arrayIndex]['units'];
	var lookup 		= SliderArray[arrayIndex]['lookup'];
	var decpoint	= parseInt(SliderArray[arrayIndex]['decpoint'], 10);
	var code 			= SliderArray[arrayIndex]['code'];
	var Mode = 'Y';
  //////////////////////////////	
  var cat = Math.floor((pos*(max - min))/200 + min);
	var cval = cat;
	if((lookup == 'Y') || (lookup == 'M'))
	{
		if(lookup == 'M'){Mode = CurrentMode;};
		cval = getLookupValue(code, Mode, cat);
	}  
	var v = (cval*mult)/divide; 
	v =  v / Math.pow(10, decpoint) + offset;
  v = v.toFixed(decpoint);
	return  v + " " + units;
}



function unblockSliderSync()
{
	BlockSliderSync = false;
}
 



function onSliderChange(sliderno)
{
	BlockSliderSync = true;
	clearTimeout(SliderBlockTimeout);
	SliderBlockTimeout = setTimeout(unblockSliderSync, 2000);

	blockFreqRead = false;
	var listIndex = getSliderListIndexFromSliderno(sliderno);
	if(listIndex == 255) {return;};
	var arrayIndex = getSliderArrayIndexFromSliderno(sliderno);
	if(listIndex == 255) {return;};
	var textid = SliderList[listIndex][2];		
	var sliderid = SliderList[listIndex][1];
	var code = SliderArray[arrayIndex]['code'];
	var vx = SliderArray[arrayIndex]['vx'];
	var pos = $("#" + sliderid).val();  // 0 to 200
	///////////////////
	var cat = posToCat(pos, arrayIndex);
	if(vx == 'V')
	{
		if(VfoRx == 'A') SliderArray[arrayIndex]['aval'] = cat;
		if(VfoRx == 'B') SliderArray[arrayIndex]['bval'] = cat;
	}
	$("#" + textid).text(catToText(cat, arrayIndex));
	if(catcomms == 'HAMLIB')
	{
		if(code == 'IFWD')
		{
			cat = Math.floor(cat);
			if(VfoRx == 'A'){cat = modeA + ' ' + cat;};
			if(VfoRx == 'B'){cat = modeB + ' ' + cat;};
		}		
	}	
	queueWebcatMessage('SLDR', VfoRx, CAT_WRITE, code, cat, true, 0);	
}

 
 function sliderResetButton(BtnListIndex)
{

	var sliderid = ButtonList[BtnListIndex][1];
	var sliderno = getSliderNoFromId(sliderid);
  var listIndex = getSliderListIndexFromSliderno(sliderno);

	var textid = SliderList[listIndex][2];

	var arrayIndex = getSliderArrayIndexFromSliderno(sliderno);
	var code = SliderArray[arrayIndex]['code'];
	var vx = SliderArray[arrayIndex]['vxx'];
	var cat = SliderArray[arrayIndex]['def'];
	if(vx == 'V')
	{
		if(VfoRx == 'A') SliderArray[arrayIndex]['aval'] = cat;
		if(VfoRx == 'B') SliderArray[arrayIndex]['bval'] = cat;
	}
	var pos = catToPos(cat, arrayIndex);
	$("#" + sliderid).val(pos); 
	$("#" + textid).text(catToText(cat, arrayIndex));
	if(catcomms == 'HAMLIB')
	{
		if(code == 'IFWD')
		{
			cat = Math.floor(cat);
			if(VfoRx == 'A'){cat = modeA + ' ' + cat;};
			if(VfoRx == 'B'){cat = modeB + ' ' + cat;};
		}		
	}		
	queueWebcatMessage('SLDR', VfoRx, CAT_WRITE, code, cat, true, 0);		
} 


//////////////////////////////////////////////////

function getSliderSettings()
{
	var code;
	var vx;
	var active;
	for(var i in SliderArray)
	{
		code = SliderArray[i]['code'];
		active = SliderArray[i]['active'];
		if((code == '') || (active == 'N') || (active == 'W')) {continue;};
		vx = SliderArray[i]['vx'];
		if(vx == 'V') {vx = VfoRx;};
		if(vx =='X') {vx = 'A';};   // must send A or B
		sendWebcatMessage('SLDR', vx, CAT_READ, code, 0, false);
	}	
} 
 

 
function SetAudioAB()
{

	if(afswap != 'Y') return;
	var arrayIndex;
	var pos;
	var sliderno;
	var sliderid;
	var textid;
	var listIndex;
	var cat;
	var newcat;
	var oldpos;
	var audioA;
	var audioB;

	arrayIndex = getSliderArrayIndexFromCode('AFGN');
	if(arrayIndex == 255) return;
	sliderno = SliderArray[arrayIndex]['sliderno'];
	listIndex = getSliderListIndexFromSliderno(sliderno);
	textid = SliderList[listIndex][2];		
	sliderid = SliderList[listIndex][1];	
	oldpos = $("#" + sliderid).val();  // 0 to 200
	
	if(VfoRx == 'B') // button press was VFOA
	{
		AudioPosB = oldpos;
		audioB = posToCat(0, arrayIndex);
		audioA = posToCat(AudioPosA, arrayIndex);
		newcat = audioA;
	}
	else 
	{
		AudioPosA = oldpos;
		audioA = posToCat(0, arrayIndex);
		audioB = posToCat(AudioPosB, arrayIndex);
		newcat = audioB;
	}; 
	queueWebcatMessage('SLDR', 'A', CAT_WRITE, 'AFGN', audioA, true, 0);		
	queueWebcatMessage('SLDR', 'B', CAT_WRITE, 'AFGN', audioB, true, 0);		
	if(VfoRx == 'B') {pos = AudioPosA;} else {pos = AudioPosB;};
	$("#" + sliderid).val(pos); 
	$("#" + textid).text(catToText(newcat, arrayIndex));				 
}
 