﻿// piWebCAT tuner routines
"use strict";

var tTop = 0;
var tLeft = 0;
var mkleft = 0;
var tWidth = 0;
var tRight = 0;


var catAnswerArray = [];

var prevx =20;

var freqMain = 3700000;

var freqSet = 3700000;

var blockMemClear = false;
var memFreq = 0;

var freqSetValid = false;

var fastCatsBlocked = false;

var timerId;

var VfoRx = 'A';
var VfoTx = 'A';

var Transmitting = false;
var split = false;




function initRxTuner()
{
	var p = $("#rxtuner").position();   // position bug in jQuery 3.3.1`  3.5.1  dont use
	tWidth = $("#rxtuner").width();
	tTop = 143;//   p.top;    // fixed - instead of jQuery position
	tLeft = 264 + 10; //    p.left + 10;  // fixed - instead of jQuery position
	tRight = tLeft + tWidth;
	mkleft = Math.floor(tLeft + 2);
}



function onClickRxTuner()
{
	var X = mouseX - tLeft;
	if(band == 255) {band = tunerband;}
	var F = bandtuner[band][TUNER_L] 
	    + ((X - bandtuner[band][TUNERX_L]) * bandtuner[band][TUNER_SPAN]) / bandtuner[band][TUNERX_SPAN]
	F = Math.floor(F);
	freqMain = F;
	freqSet = F;
	setFreqDisplayMain(F);
	blockFreqRead = true;


	startClearBlockFreqReadTimer();
	
	var jobdata = freqSet.toString(10);
	queueWebcatMessage('FREQ', VfoRx, CAT_WRITE, 'FREQ', jobdata, true, 0);
	$("#MemIndicator").text("");	
}	


function setFreqCatCallback()  // timing - this callback from server  - not radio!!
{
}



function getFreqCurCat()
{
	if(blockFreqRead) return;
	if(StopRepitasks) return;
	if(mouseInTunerA()) return;
	queueWebcatMessage('FREQ', VfoRx, CAT_READ, 'FREQ', 0, true, 0);	
}


function getFreqZzCat()
{
	if(blockFreqRead) return;
	if(StopRepitasks) return;
	if(mouseInTunerA()) return;
	var ab = 'B';
	if(VfoRx == 'B') {ab = 'A';};
	queueWebcatMessage('FREQ', ab, CAT_READ, 'FREQ', 0, true, 0);		
}




function getFreqCatCallback()
{
  if(blockFreqRead) return;
  var f = catAnswerArray["value"];
  var rxab = catAnswerArray["rxab"];
  if(f <20000){ return;};
  
  if(rxab == VfoRx)
  {
		freqMain = f;
		freqSet = f;
		freqSetValid = true;
		setFreqDisplayMain(f);
		if(blockMemClear == false)
		{
			if(memFreq == 0) { memFreq = f;};
			if(memFreq != f) {$("#MemIndicator").text("");};	
		}	
	}	
	else
	{
		setFreqDisplaySub(f);
	}	
}
	


function padToThree(num) 
{
  var s;
  if(num > 99) return num.toString(10);
  if(num > 9)
  {
  	s = "0" + num.toString(10);
	}
	else
	{
	  s = "00" + num.toString(10);
	}    
	return s;
}



function setFreqDisplayMain(ff)
{
	var fh = padToThree(ff % 1000);
  var f = Math.floor(ff / 1000);
  var fk = padToThree(f % 1000);
  var fm = Math.floor(f / 1000);
	var fs = fm + '.' + fk + '.' + fh;
	if(ff < 10000000) fs = "&nbsp;" + fs;
	$("#freqsel").html(fs);
	doTuningPoint(ff);
}



function setFreqDisplaySub(ff)
{
	var fh = padToThree(ff % 1000);
  var f = Math.floor(ff / 1000);
  var fk = padToThree(f % 1000);
  var fm = Math.floor(f / 1000);
	var fs = fm + '.' + fk + '.' + fh;
	if(ff < 10000000) fs = "&nbsp;" + fs;
	$("#freqnosel").html(fs);
}



//////////////////////////////////////////////////////////////

function drawTuningPoint(x, clr)
{
	var tpColor = clr;
	if(x < 3 ){ x = 3; tpColor = "olive";};
	if(x > tWidth - 17) {x = tWidth - 17; tpColor = "olive";};
	$('#rxtuner').line(tLeft + prevx + 1, tTop + 28, tLeft+ prevx + 1, tTop + 45,  {stroke:10, color:"black"});
	prevx = x;		
	$('#rxtuner').line(tLeft + x + 1, tTop + 30, tLeft+ x + 1, tTop + 45,  {stroke:8, color:tpColor});		
}



////////////////////////////////////////////////////////////

function drawTuner160m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "1p8", class: "freqmarker", text: "1.8"  }).appendTo("#rxtuner"); 
	$("#1p8").css( "left", "+=6" );
	$("<div/>", {id: "1p9", class: "freqmarker", text: "1.9"  }).appendTo("#rxtuner"); 
	$("#1p9").css( "left", "+=346" );
	$("<div/>", {id: "2p0", class: "freqmarker", text: "2.0"  }).appendTo("#rxtuner"); 
	$("#2p0").css( "left", "+=686" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner80m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<31;i++)
	{
		var x = tLeft + 20 + 23*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "3p5", class: "freqmarker", text: "3.5"  }).appendTo("#rxtuner"); 
	$("#3p5").css( "left", "+=6" ); 
	$("<div/>", {id: "3p6", class: "freqmarker", text: "3.6"  }).appendTo("#rxtuner"); 
	$("#3p6").css( "left", "+=236" );
	$("<div/>", {id: "3p7", class: "freqmarker", text: "3.7"  }).appendTo("#rxtuner"); 
	$("#3p7").css( "left", "+=466" );
	$("<div/>", {id: "3p8", class: "freqmarker", text: "3.8"  }).appendTo("#rxtuner"); 
	$("#3p8").css( "left", "+=696" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}	




function drawTuner60m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<32;i++)
	{
		var x = tLeft + 20 + 22*i;
		if(((i + 1) % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "5p26", class: "freqmarker", text: "5.26"  }).appendTo("#rxtuner"); 
	$("#5p26").css( "left", "+=27" ); // no action
	$("<div/>", {id: "5p30", class: "freqmarker", text: "5.30"  }).appendTo("#rxtuner"); 
	$("#5p30").   css( "left", "+=203" );
	$("<div/>", {id: "5p35", class: "freqmarker", text: "5.35"  }).appendTo("#rxtuner"); 
	$("#5p35").css( "left", "+=423" );
	$("<div/>", {id: "5p40", class: "freqmarker", text: "5.40"  }).appendTo("#rxtuner"); 
	$("#5p40").css( "left", "+=643" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}





function drawTuner40m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "7p0", class: "freqmarker", text: "7.0"  }).appendTo("#rxtuner"); 
	$("#7p0").css( "left", "+=6" );
	$("<div/>", {id: "7p1", class: "freqmarker", text: "7.1"  }).appendTo("#rxtuner"); 
	$("#7p1").css( "left", "+=346" );
	$("<div/>", {id: "7p2", class: "freqmarker", text: "7.2"  }).appendTo("#rxtuner"); 
	$("#7p2").css( "left", "+=686" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner30m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<26;i++)
	{
		var x = tLeft + 20 + 27*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "10p10", class: "freqmarker", text: "10.10"  }).appendTo("#rxtuner"); 
	$("#10p10").css( "left", "+=1" ); // no action
	$("<div/>", {id: "10p11", class: "freqmarker", text: "10.11"  }).appendTo("#rxtuner"); 
	$("#10p11").css( "left", "+=130" );	
	$("<div/>", {id: "10p12", class: "freqmarker", text: "10.12"  }).appendTo("#rxtuner"); 
	$("#10p12").css( "left", "+=265" );
	$("<div/>", {id: "10p13", class: "freqmarker", text: "10.13"  }).appendTo("#rxtuner"); 
	$("#10p13").css( "left", "+=400" );
	$("<div/>", {id: "10p14", class: "freqmarker", text: "10.14"  }).appendTo("#rxtuner"); 
	$("#10p14").css( "left", "+=535" );
	$("<div/>", {id: "10p15", class: "freqmarker", text: "10.15"  }).appendTo("#rxtuner"); 
	$("#10p15").css( "left", "+=670" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}






function drawTuner20m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<36;i++)
	{
		var x = tLeft + 20 + 19*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "14p0", class: "freqmarker", text: "14.0"  }).appendTo("#rxtuner"); 
	$("#14p0").css( "left", "-=5" ); // no action
	$("<div/>", {id: "14p1", class: "freqmarker", text: "14.1"  }).appendTo("#rxtuner"); 
	$("#14p1").css( "left", "+=185" );
	$("<div/>", {id: "14p2", class: "freqmarker", text: "14.2"  }).appendTo("#rxtuner"); 
	$("#14p2").css( "left", "+=375" );
	$("<div/>", {id: "14p3", class: "freqmarker", text: "14.3"  }).appendTo("#rxtuner"); 
	$("#14p3").css( "left", "+=565" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner17m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<22;i++)
	{
		var x = tLeft + 20 + 32*i;
		if(((i +1) % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "18p07", class: "freqmarker", text: "18.07"  }).appendTo("#rxtuner"); 
	$("#18p07").css( "left", "+=27" ); // no action
	$("<div/>", {id: "18p09", class: "freqmarker", text: "18.09"  }).appendTo("#rxtuner"); 
	$("#18p09").   css( "left", "+=155" );
	$("<div/>", {id: "18p11", class: "freqmarker", text: "18.11"  }).appendTo("#rxtuner"); 
	$("#18p11").css( "left", "+=283" );
	$("<div/>", {id: "18p13", class: "freqmarker", text: "18.13"  }).appendTo("#rxtuner"); 
	$("#18p13").css( "left", "+=411" );
	$("<div/>", {id: "18p15", class: "freqmarker", text: "18.15"  }).appendTo("#rxtuner"); 
	$("#18p15").css( "left", "+=539" );
	$("<div/>", {id: "18p17", class: "freqmarker", text: "18.17"  }).appendTo("#rxtuner"); 
	$("#18p17").css( "left", "+=667" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner15m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<46;i++)
	{
		var x = tLeft + 20 + 15*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "21p0", class: "freqmarker", text: "21.0"  }).appendTo("#rxtuner"); 
	$("#21p0").css( "left", "-=5" ); // no action
	$("<div/>", {id: "21p1", class: "freqmarker", text: "21.1"  }).appendTo("#rxtuner"); 
	$("#21p1").css( "left", "+=145" );
	$("<div/>", {id: "21p2", class: "freqmarker", text: "21.2"  }).appendTo("#rxtuner"); 
	$("#21p2").css( "left", "+=295" );
	$("<div/>", {id: "21p3", class: "freqmarker", text: "21.3"  }).appendTo("#rxtuner"); 
	$("#21p3").css( "left", "+=445" );
	$("<div/>", {id: "21p4", class: "freqmarker", text: "21.4"  }).appendTo("#rxtuner"); 
	$("#21p4").css( "left", "+=595" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}




function drawTuner12m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "24p89", class: "freqmarker", text: "24.89"  }).appendTo("#rxtuner"); 
	$("#24p89").css( "left", "-=1" ); // no action
	$("<div/>", {id: "24p91", class: "freqmarker", text: "24.91"  }).appendTo("#rxtuner"); 
	$("#24p91").   css( "left", "+=131" );
	$("<div/>", {id: "24p93", class: "freqmarker", text: "24.93"  }).appendTo("#rxtuner"); 
	$("#24p93").css( "left", "+=267" );
	$("<div/>", {id: "24p95", class: "freqmarker", text: "24.95"  }).appendTo("#rxtuner"); 
	$("#24p95").css( "left", "+=403" );
	$("<div/>", {id: "24p97", class: "freqmarker", text: "24.97"  }).appendTo("#rxtuner"); 
	$("#24p97").css( "left", "+=539" );
	$("<div/>", {id: "24p99", class: "freqmarker", text: "24.99"  }).appendTo("#rxtuner"); 
	$("#24p99").css( "left", "+=675" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner10m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<35;i++)
	{
		var x = tLeft + 20 + 20*i;
		if((i % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "21p0", class: "freqmarker", text: "28.0"  }).appendTo("#rxtuner"); 
	$("#21p0").css( "left", "-=5" ); // no action
	$("<div/>", {id: "28p5", class: "freqmarker", text: "28.5"  }).appendTo("#rxtuner"); 
	$("#28p5").css( "left", "+=195" );
	$("<div/>", {id: "29p0", class: "freqmarker", text: "29.0"  }).appendTo("#rxtuner"); 
	$("#29p0").css( "left", "+=395" );
	$("<div/>", {id: "29p5", class: "freqmarker", text: "29.5"  }).appendTo("#rxtuner"); 
	$("#29p5").css( "left", "+=595" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}



function drawTuner6m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "50p0", class: "freqmarker", text: "50.0"  }).appendTo("#rxtuner"); 
	$("#50p0").css( "left", "-=5" ); // no action
	$("<div/>", {id: "50p5", class: "freqmarker", text: "50.5"  }).appendTo("#rxtuner"); 
	$("#50p5").   css( "left", "+=166" );
	$("<div/>", {id: "51p0", class: "freqmarker", text: "51.0"  }).appendTo("#rxtuner"); 
	$("#51p0").css( "left", "+=336" );
	$("<div/>", {id: "51p5", class: "freqmarker", text: "51.5"  }).appendTo("#rxtuner"); 
	$("#51p5").css( "left", "+=506" );
	$("<div/>", {id: "52p0", class: "freqmarker", text: "52.0"  }).appendTo("#rxtuner"); 
	$("#52p0").css( "left", "+=676" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}







function drawTuner4m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<26;i++)
	{
		var x = tLeft + 20 + 28*i;
		if((i % 5) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "70p0", class: "freqmarker", text: "70.0"  }).appendTo("#rxtuner"); 
	$("#70p0").css( "left", "-=5" );
	
	$("<div/>", {id: "70p1", class: "freqmarker", text: "70.1"  }).appendTo("#rxtuner"); 
	$("#70p1").css( "left", "+=135" );

	$("<div/>", {id: "70p2", class: "freqmarker", text: "70.2"  }).appendTo("#rxtuner"); 
	$("#70p2").css( "left", "+=275" );

	$("<div/>", {id: "70p3", class: "freqmarker", text: "70.3"  }).appendTo("#rxtuner"); 
	$("#70p3").css( "left", "+=415" );
	
	$("<div/>", {id: "70p4", class: "freqmarker", text: "70.4"  }).appendTo("#rxtuner"); 
	$("#70p4").css( "left", "+=555" );
		
	$("<div/>", {id: "70p5", class: "freqmarker", text: "70.5"  }).appendTo("#rxtuner"); 
	$("#70p5").css( "left", "+=695" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}







function drawTuner2m()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "144p0", class: "freqmarker", text: "144"  }).appendTo("#rxtuner"); 
	$("#144p0").css( "left", "+=6" );
	$("<div/>", {id: "145p0", class: "freqmarker", text: "145"  }).appendTo("#rxtuner"); 
	$("#145p0").css( "left", "+=346" );
	$("<div/>", {id: "146p0", class: "freqmarker", text: "146"  }).appendTo("#rxtuner"); 
	$("#146p0").css( "left", "+=686" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}







function drawTuner70cm()
{
	$("#rxtuner").html("");	
	$('#rxtuner').line(tLeft+5, tTop+29, tLeft+726, tTop+29,  {stroke:2, color:"white"});
	var i, h;
	for(i=0;i<21;i++)
	{
		var x = tLeft + 20 + 34*i;
		if((i % 2) == 0) {h = 8;} else {h = 4;}
		$('#rxtuner').line(x, tTop + 29 - h, x, tTop + 29,  {stroke:2, color:"white"});		
	}
	$("<div/>", {id: "430p0", class: "freqmarker", text: "430"  }).appendTo("#rxtuner"); 
	$("#430p0").css( "left", "+=2" );
	
	$("<div/>", {id: "432p0", class: "freqmarker", text: "432"  }).appendTo("#rxtuner"); 
	$("#432p0").css( "left", "+=138" );

	$("<div/>", {id: "434p0", class: "freqmarker", text: "434"  }).appendTo("#rxtuner"); 
	$("#434p0").css( "left", "+=275" );

	$("<div/>", {id: "436p0", class: "freqmarker", text: "436"  }).appendTo("#rxtuner"); 
	$("#436p0").css( "left", "+=410" );
	
	$("<div/>", {id: "438p0", class: "freqmarker", text: "438"  }).appendTo("#rxtuner"); 
	$("#438p0").css( "left", "+=547" );
		
	$("<div/>", {id: "440p0", class: "freqmarker", text: "440"  }).appendTo("#rxtuner"); 
	$("#440p0").css( "left", "+=683" );
	$('.freqmarker').css("left", "+=" + mkleft.toString() );
}




