<?php

// wccoder.php   -  yaesu etc mask handling


require_once 'wctaskmysql.php';


///////////////////////////////////////////////////////////////////////////////////


$Coder = new CoderClass;


class CoderClass
{	

	public function MatchingByte($ch)
	{	
		switch($ch)
		{
			case 'g':
			case 'f':
			case 'e':
			case 'd':
			case 'c':
			case 'm':   // thousands
			case 'h':
			case 't':
			case 'u':
			case 'y':
			case 'x':
			case 's':     /// sign 		
			case 'b':     //hex to dec
			case 'a':	    //hex to dec 2s comp
				return true;    
			default: return false;	
		}
	}


	public function BuildReadFrame($jobdata)
	{
		global $readMask;
		global $readBytes;
		return $this->BuildFrame($jobdata, $readMask, $readBytes);
	}
	


	public function BuildSetFrame($jobdata)
	{
		global $setMask;
		global $setBytes;
		return $this->BuildFrame($jobdata, $setMask, $setBytes);
	
		
	}
	
	
	public function BuildFrame($jobdata, $mask, $bytes)
	{
		global $catcomms;

		$nj = strlen($jobdata);
		if((!is_numeric($jobdata)) && ($nj == 1))
		{
			return str_replace("u", $jobdata,$mask);
		};  // eg 'E' for PKT mode in Ftdx101D 
		$sign = '+';
		
		$d = abs($jobdata);
		$catString = '';	
		$ix = 0;
		$hex = '';
		if($catcomms == 'YAESU5')
		{
			$bCount = 0;
			$bStart = -1;
			for($i=0;$i<$bytes;$i++)
			{
				if($mask[$i] == 'b')
				{
					if($bCount == 0){$bStart = $i;}
					$bCount++;
				}	
			}
			if($bCount > 0)
			{
				$hex	= '00000000' . dechex($d);
				$hex = substr($hex, -$bCount);		
			}	
		}			
		for($i=0; $i<$bytes; $i++)
		{   
			$ch = $mask[$i];
			if(!$this->MatchingByte($ch))
			{
				$catString[$i] = $ch;
			}
			else
			{		
				switch($ch)
				{		
					case 'g': $catString[$i] = chr(48 + ($d  % 1000000000)/100000000); break;
					case 'f': $catString[$i] = chr(48 + ($d  % 100000000)/10000000); break;
					case 'e': $catString[$i] = chr(48 + ($d  % 10000000)/1000000); break;
					case 'd': $catString[$i] = chr(48 + ($d  % 1000000)/100000); break;
					case 'c': $catString[$i] = chr(48 + ($d  % 100000)/10000); break;			
					case 'm': $catString[$i] = chr(48 + ($d  % 10000)/1000); break;
					case 'h': $catString[$i] = chr(48 + ($d  % 1000)/100); break;
					case 't': $catString[$i] = chr(48 + ($d  % 100)/10); break;
					case 'u': $catString[$i] = chr(48 + ($d  % 10)); break;
					
					case 'x': 
					case 'y': $catString[$i] = $jobdata[$ix++]; break;
					case 'b': {
											$catString = $catString . $hex;
											$i = $i + $bCount - 1;
											break;
										}	
					case 's':
					{
						if($jobdata < 0) $sign = '-'; else $sign = '+';
						$catString[$i] = $sign;
						break;					
					}
				} // end sswitch
			}
		}
		return $catString;
	}
	


//this is pre-send processing for subsequenct answer processing
public function processY5AnswerMask()
{	
	global $answerMask;
	global $portRxBytes;
	global $extractStart;
	global $extractCount;
	global $extractBitMask;
	global $extractAnswerMask;

	$m = $answerMask;
	if(strlen($m) < 11){ return false;};
	if(($m[0] != '#') || ($m[3] != ':') || ($m[6] != ':') || ($m[9] != ':')){return false;}
	$portRxBytes = intval(substr($m,1,2),10);
	$extractStart = intval(substr($m,4,2),10);
	$extractCount = intval(substr($m,7,2),10);
	$extractBitMask = intval(substr($m,10,2),16);
	$answerMask = substr($m,13);
	return true;
}	
	
	

	
	
	
	
public function ProcessAnswer($answer, &$ansValue)
{ 
	global $catcomms;
	global $answerMask;
	global $answerBytes;
	global $modcat;
	global $catString;
	global $hexAnsX;
	global $hexAnsY;
	global $hexToDec;
	global $hexToDec2sC;

	if($hexAnsX || $hexAnsY || $hexToDec || $hexToDec2sC)
	{
		$ansValue = $answer;
		return true;
	};
	//	return $this->ParseAnswer($answer, $ansValue);
	
	
	$ansData = $answer;
	return $this->ParseAnswer($ansData, $ansValue);
}
	
	
	
	// used for $catcomm = 'ASCII'   and HAMLIB \send_cmd_rx
public function ParseAnswer($answer, &$ansValue)
{ 
	global $answerBytes;
	global $answerMask;
	$negative = false;
	$DecimalAsciiData = false;
	$BinaryData = false;
	$ansValue = 0;
	
	$isHex = false;
	$allHex = true;
	
	for($i=0; $i<$answerBytes; $i++)
	{
		if($answerMask[$i] == 'x'){$isHex = true;};
		if($answerMask[$i] != 'x'){$allHex = false;};
	}
	if($isHex)
	{	 
		if($allHex == false){return false;};
		if(strlen($answer) != $answerBytes){return false;};
		$ansValue = $answer;
		return true;
	}
	
	for($i=0; $i<$answerBytes; $i++)
	{
		$b = $answer[$i];
		$mb = $answerMask[$i];		
		if($mb == '$') {continue;};  // '$' in mask is 'dont care .. so not action on returned byte 
		if(!$this->MatchingByte($mb))
		{
			if($mb != $b) return false;   // must match - so failed
		}	
	  if($mb == 's')
		{
			switch($b)
			{
				case '-': $negative = true; break;
				case '+' : break;
				default: return false;
			}
		}
		$mult = 0;
		switch($mb)
		{
			case 'g': $mult = 100000000; break;	// hundred millions
			case 'f': $mult = 10000000; break;		// ten millions
			case 'e': $mult = 1000000; break;		// millions
			case 'd': $mult = 100000; break;			// hundred thousands
			case 'c': $mult = 10000; break;			// ten thousands
			case 'm': $mult = 1000; break;				// thousands
			case 'h': $mult = 100; break;				// hundreds
			case 't': $mult = 10; break;					// tens	
			case 'u': $mult = 1; break;          // units
		}
		
		if($mult != 0)
		{
			$DecimalAsciiData = true;
			if(($b <'0') || ($b >'9'))
			{
			 	$ansValue = $b;  // FTdx101D returns 'A' for roofer 300Hz and 'E' for PKT (PSK) mode
			  break;						// this code only copes with single character data
			}  
			else
			{ 
			 //return false;  // must be a valid decimal char
				$ansValue += ($b)*$mult;
				continue;
			}	
		}
	}	
	if($negative) $ansValue *= -01;
	

	return true;
}	
	
	
	
public function AnswerY5toText($answer)
{ 
	global $extractCount; // = no of bytes for processing
	global $answerMask;    // already modified to match only the extract
	global $extractBitMask;
	global $answerBytes;

	global $hexAnsX;
	global $hexAnsY;
	global $hexToDec;
	global $hexToDec2sC;
		
	if(strlen($answerMask) != $answerBytes) {return false;};
	
	$hexAnsX = false;  //  return (data AND mask)
	$hexAnsY = false;  // return 01 if ANY  bit in mask
	$hexToDec = false;
	$hexToDec2sC = false;
	
	for($i=0;$i<$answerBytes;$i++)
	{
		if(!$this->MatchingByte($answerMask[$i])) {return false;};
		
		if($answerMask[$i] == 'x') {$hexAnsX = true;};
		if($answerMask[$i] == 'y') {$hexAnsY = true;};
		if($answerMask[$i] == 'b') {$hexToDec = true;};
		if($answerMask[$i] == 'a') {$hexToDec2sC = true;};

	}	

	if($hexAnsX)
	{
		for($i=0;$i<$answerBytes;$i++) 
		{
			if($answerMask[$i] != 'x') return false;
		};		
	}
	
	if($hexAnsY)
	{
		for($i=0;$i<$answerBytes;$i++) 
		{
			if($answerMask[$i] != 'y') return false;
		};		
	}
	
	
	if($hexToDec)
	{
		for($i=0;$i<$answerBytes;$i++) 
		{
			if($answerMask[$i] != 'b') return false;
		};		
	}


	
	if($hexToDec2sC)
	{
		for($i=0;$i<$answerBytes;$i++) 
		{
			if($answerMask[$i] != 'a') return false;
		};		
	}


	if($extractCount == 1)
	{
		$b = ord($answer[0]);
		if($hexAnsY)
		{
		$b &= $extractBitMask;	
		if(($b ^ $extractBitMask) > 0) {$answer[0] = chr(0x01);} else {$answer[0] = chr(0x00);};
//			echo '+++' . $b . '+++' . $extractBitMask . '+++'. ord($answer[0]);
		}
		else
		{	
			$b &= $extractBitMask;
			$answer[0] = chr($b);
		}
	}	
	
	$answer = strtoupper(bin2hex($answer));
	
	
	$answer = str_pad($answer, 2*$extractCount,"0", STR_PAD_LEFT);	
	
	if($hexToDec)
	{
		$dec = hexdec($answer);
		$answer = str_pad(strval($dec), $answerBytes,"0", STR_PAD_LEFT);
	}	


	if($hexToDec2sC)
	{
		$dec = hexdec($answer);
		$maxhex = 15*$answerBytes;   // for 2x compliment
		if($dec > 32767) {$dec = -(65536 - $dec);};
		$answer = str_pad(strval($dec), $answerBytes,"0", STR_PAD_LEFT);
	}	

	return $answer;
	
	
	
	
}	
	
	
}	// end class
	



?>