<?php

// wccoderciv.php   -  yaesu etc mask handling


require_once 'wctaskmysql.php';


///////////////////////////////////////////////////////////////////////////////////


/*
$rigaddr 		= '00';
$rpiaddr 		= 'E0';
$cmdtype 		= 'xxxx';
$datadigits = 0;
$com    		= 'FF';
$subcom			= 'FF';
$subcom4or6	= 59999;
$sendBytesCiv = 0;	
$answerBytesCiv = 0;
$dataIndexCiv = 0;  // expected start index of bcd data in answer string
$bcdbytes = 0;
$catStringCiv = '';

*/

$CoderCiv = new CoderCivClass;


class CoderCivClass
{	 


public function ParseBandStackingAnswer($answer, &$freq, &$mode)
{
	$mode = ord($answer[13]);
	$freq = 0;
	for($i=12;$i>=8;$i--)	
	{
		$freq *= 100;
		$b = ord($answer[$i]);
		$freq += (10*floor($b/16) + ($b % 16));
	}	
	return true;
} 


public function ParseAnswer($answer, &$ansValue)
{ 

	global $rigaddr;
	global $rpiaddr;
	global $cmdtype;
	global $datadigits;
	global $answerBytesCiv;
	global $dataIndexCiv;
	global $bcdbytes;
	global $catStringCiv;
	global $com;
	
	$BinaryData = false;
	$ansValue = 0;

	if($answer[0] != chr(0xFE)) return false;
	if($answer[1] != chr(0xFE)) return false;
	if($answer[2] != $catStringCiv[3]) return false;
	if($answer[3] != $catStringCiv[2]) return false; 
	//if($answer[4] != $catStringCiv[4]) return false;
	if($answer[$answerBytesCiv - 1] != chr(0xFD)) return false;
	if($bcdbytes  == 0) return true;
	
	if($com == 0x03)    // frequncy read - byte order reversed !!!
	{
		for($i=($bcdbytes-1);$i>=0;$i--)	
		{
			$ansValue *= 100;
			$b = ord($answer[$dataIndexCiv + $i]);
			$ansValue += (10*floor($b/16) + ($b % 16));
		}	
	}
	else
	{
		for($i=0;$i<$bcdbytes;$i++)	
		{
			$ansValue *= 100;
			$b = ord($answer[$dataIndexCiv + $i]);
			$ansValue += (10*floor($b/16) + ($b % 16));
		}
	}		
	return true;
}




/////////////////////////////

	public function BuildReadFrameCiv()
	{
		return $this->BuildFrameCiv(0,true);
	}


	public function BuildSetFrameCiv($jobdata)
	{
		return $this->BuildFrameCiv($jobdata, false);	
	}
	
	
	
	
/*	
	// for catcomms == 'CIV'
$rigaddr 		= '00';
$rpiaddr 		= 'E0';;
$cmdtype 		= 'xxxx';
$digitssend = 0;
$digitsrec	= 0;
$com    		= 'FF';
$subcom			= 'FF';
$subcom4or6	= 59999;
*/


	public function BuildFrameCiv($jobdata, $FrameIsRead)
	{
		global $rigaddr;
		global $rpiaddr;
		global $cmdtype;
		global $com;
		global $subcom;
		global $subcom4or6;
		global $sendBytesCiv;
		global $answerBytesCiv;
		global $dataIndexCiv;
		global $datadigits;
		global $bcdbytes;
		$x = $jobdata;
		$ndec = $datadigits;
		$sfs = $subcom4or6;
		$bcdbytes = 0;
		$catString = pack("C18",0xFE,0xFE,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		$catString[2] = chr(hexdec($rigaddr));
		$catString[3] = chr(hexdec($rpiaddr));
		////////////////////
		// FIXED icom write > read substitutions   ...  all rigs
		if($FrameIsRead)
		{
			if($com == 0x06) {$com = 0x04;};
			if($com == 0x05) {$com = 0x03;};
		}
		//////////////////////
		$catString[4] = chr(hexdec($com));
		switch($cmdtype)
		{
			case 'C_S_DATA':
				{		
					$dataIndexCiv = 6;  // FE FE E0 70  com subcom  data....   data starts at byte 6
					$catString[5] = chr(hexdec($subcom));
					$bcdbytes = intdiv(($ndec + 1),2);
					$dbytes = 0;   // no data in a  read comment
					if($FrameIsRead == false)
					{
						$dbytes = $bcdbytes;  // data in write command
						for($i=$bcdbytes;$i>=1;$i--)
						{
							$d = $x % 100;
							$bcd = ($d % 10) + 16*floor($d / 10);
							$catString[5 + $i] = chr($bcd);
							$x /= 100;
						}
					}	
					$catString[6 + $dbytes] = chr(0xFD);
					if($FrameIsRead) 
					{
						$sendBytesCiv = 7;
						$answerBytesCiv = 7 + $bcdbytes; 
					} 
					else 
					{
						$sendBytesCiv = 7 + $bcdbytes;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}
					break;
				};
				
			case 'C_S6_DATA':
				{
					$dataIndexCiv = 8; 					
					// build subcommand  - 3 bcd bytes   eg: 50114 > 0x05  0x01  0x14
					$d = $sfs % 100;
					$bcd = ($d % 10) + 16*floor($d / 10);
					$catString[7] = chr($bcd);
					$sfs = floor($sfs / 100);
					$d = $sfs % 100;
					$bcd = ($d % 10) + 16*floor($d / 10);					
					$catString[6] = chr($bcd);
					$sfs = floor($sfs/100);
					$bcd = ($sfs % 10) + 16*floor($sfs / 10);					
					$catString[5] = chr($bcd);
					// now build bcd data bytes
					$bcdbytes = intdiv(($ndec + 1), 2);				
					$dbytes = 0;	
					if($FrameIsRead == false)
					{
						$dbytes = $bcdbytes;
						for($i=$bcdbytes;$i>=1;$i--)
						{
							$d = $x %100;
							$bcd = ($d % 10) + 16*floor($d / 10);							
							$catString[7 + $i] = chr($bcd);
							$x /= 100;
						}
					}
					$catString[8 + $dbytes] = chr(0xFD);
					if($FrameIsRead) 
					{
						$sendBytesCiv = 9;
						$answerBytesCiv = 9 + $bcdbytes; 
					} 
					else 
					{
						$sendBytesCiv = 9 + $bcdbytes;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}
					break;
				};
			
			case 'C_S4_DATA':
				{
					$dataIndexCiv = 7;
					// buidsubcommand = 2 bcd bytes
					$d = $sfs % 100;
					$bcd = ($d % 10) + 16*floor($d / 10);					
					$catString[6] = chr($bcd);
	
					$sfs = floor($sfs/100);
					$bcd = ($sfs % 10) + 16*floor($sfs / 10);					
					$catString[5] = chr($bcd);
					$bcdbytes = intdiv(($ndec + 1), 2);					
					// now build bcd data bytes
					$dbytes = 0;
					if($FrameIsRead == false)
					{
						$dbytes = $bcdbytes;
						for($i=$bcdbytes;$i>=1;$i--)
						{
							$d = $x %100;
							$bcd = ($d % 10) + 16*floor($d / 10);							
							$catString[6 + $i] = chr($bcd);
							$x /= 100;
						}
					}					
					$catString[7 + $dbytes] = chr(0xFD);
					if($FrameIsRead) 
					{
						$sendBytesCiv = 8;
						$answerBytesCiv = 8 + $bcdbytes; 
					} 
					else 
					{
						$sendBytesCiv = 8 + $bcdbytes;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}
					break;
				};	
			
			case 'C_S_ONOFF':
				{
					$dataIndexCiv = 6;
					$bcdbytes = 1;
					$catString[5] = chr(hexdec($subcom));
					if($FrameIsRead == false)
					{
						$catString[6] = chr($jobdata);
						$catString[7] = chr(0xFD);
					}
					else
					{
						$catString[6] = chr(0xFD);
					}	
					if($FrameIsRead) 
					{
						$sendBytesCiv = 7;
						$answerBytesCiv = 8; 
					} 
					else 
					{
						$sendBytesCiv = 8;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}	
					break;
				};	
			
			case 'C_S':
				{
					$bcdbytes = 0;// no retuned data
					$catString[5] = chr(hexdec($subcom));
					$catString[6] = chr(0xFD);
					$sendBytesCiv = 7;
					$answerBytesCiv = 6;     // 6 byte ok messag					
					break;
				}	
			case 'C_ONLY':
				{
					$bcdbytes = 0;// no retuned data
					$catString[5] = chr(0xFD);
					$sendBytesCiv = 6;
					$answerBytesCiv = 6;     // 6 byte ok messag					
					break;
				}	
			case 'C_ONOFF':
				{
					$dataIndexCiv = 5;
					$bcdbytes = 1;
					$catString[5] = chr($jobdata);
					$catString[6] = chr(0xFD);		
					if($FrameIsRead) 
					{
						$sendBytesCiv = 6;
						$answerBytesCiv = 7; 
					} 
					else 
					{
						$sendBytesCiv = 7;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}
					break;
				};	
			
			case 'C_DATA':
				{
					$dataIndexCiv = 5;
					$bcdbytes = intdiv(($ndec + 1), 2);
					$dbytes = 0;
					if($FrameIsRead == false)
					{
						$dbytes = $bcdbytes;
						if($com == 0x05)
						{
							for($i=1;$i<=$bcdbytes;$i++)
							{
								$d = $x %100;
								$bcd = ($d % 10) + 16*floor($d / 10);							
								$catString[4 + $i] = chr($bcd);
								$x /= 100;
							}
						}
						else
						{
							for($i=$bcdbytes;$i>=1;$i--)
							{
								$d = $x %100;
								$bcd = ($d % 10) + 16*floor($d / 10);							
								$catString[4 + $i] = chr($bcd);
								$x /= 100;
							}
						}	
					}
					$catString[5 + $dbytes] = chr(0xFD);
					if($FrameIsRead) 
					{
						$sendBytesCiv = 6;
						$answerBytesCiv = 6 + $bcdbytes; 
						if($com == 0x04) $answerBytesCiv = 8;  // returns 2 BCD bytes  (no mention indocumentation!!!)
					} 
					else 
					{
						$sendBytesCiv = 6 + $bcdbytes;
						$answerBytesCiv = 6;     // 6 byte ok messag
					}
					break;
				};	
			default: break;
		}// end switch	
  	return $catString;
  }
 
} 


?>




