<?php


$Hamlib = new HamlibClass;

$port = 4532;

$sendCmdRx;
	
class HamlibClass
{	

	//  --set-conf=timeout=1000.0
	
	public function startRigctld($hamlib, $tty, $baudrate, $stopbits, $charbits, $civaddr, $vfomode)
	{
		if($hamlib == 0) return;
		set_time_limit(5);		
		shell_exec("killall rigctld &");	
		$s = "rigctld -m " . $hamlib . " -r " . $tty . " -s " . $baudrate;
		if($vfomode == 'Y'){$s .= " --vfo";};
		$s .= " --set-conf=data_bits=" . $charbits . ",stop_bits=" . $stopbits . " -c " . $civaddr;
		$s .= " > /dev/null &"; 
 		$ret =  shell_exec($s);		
		sleep(1);
		return $ret;
	}




	public function restartRigctld()
	{
		global $hamlib;
		global $tty;
		global $baudrate;
		global $stopbits;
		global $charbits;
		global $civaddr;
		global $vfomode;
		$this->startRigctld($hamlib, $tty, $baudrate, $stopbits, $charbits, $civaddr, $vfomode);
	}


	public function hamlibBuildReadFrame($jobdata)
	{
		global $answerMask;   // only used for \send_cmd 
		global $readMask; 
		$res = $readMask;
		if(strpos($readMask, '#')) $res = str_replace("#", $jobdata, $res);
		return $res . "\n"; 		
	}


	public function hamlibBuildSetFrame($jobdata)
	{
		global $setMask;
		global $sendCmdRx;
		$sendCmdRx = false;
		if(substr($setMask, 0, 12) == "\send_cmd_rx")
		{
			$sendCmdRx = true;
			$p = strrpos($setMask, "--n",0);			
			if(!($p === false))
			{
				$n = (int)$setMask[$p + 3];			
				$jobdata = floor($jobdata); // remove decimals then add leading spaces
				$jobdata = str_pad($jobdata, $n, '0', STR_PAD_LEFT);
				$setMask = substr($setMask, 0, ($p-1));    // remove "--n"
			}	
			$res = $setMask;
			if(strpos($setMask, '#')) $res = str_replace("#",  $jobdata, $res);
		}
		else
		{
			$res = $setMask;
			if(strpos($setMask, '#')) $res = str_replace("#",  $jobdata, $res);
		}
		$res  .= "\n"; 		
		return $res;			
	}


	public function socketCreateConnect()
	{
		global $port;
		$dest = "127.0.0.1";
		$SocketCreationFails = 0;
		$SocketCreatedOk = false;
		while($SocketCreatedOk == false)
		{
			$SocketCreationFails++;
			$skt = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
			if($skt != false) 
			{ 
				$SocketCreatedOk = true;
			} 
			else 
			{
				if($SocketCreationFails > 4) return false;
				uSleep(2000);
			}
		}	
		socket_set_option($skt, SOL_SOCKET, SO_RCVTIMEO, array('sec' => 2, 'usec' => 0));
		socket_set_option($skt, SOL_SOCKET, SO_SNDTIMEO, array('sec' => 1, 'usec' => 0));				
		usleep(1600);
		$SocketConnectionFails = 0;
		$SocketConnectedOk = false;
		while($SocketConnectedOk == false)
		{
			$SocketConnectionFails++;
			if(socket_connect($skt, $dest, $port) != false)
			{ 
				$SocketConnectedOk = true;
			} 
			else 
			{
				if($SocketConnectionFails > 4) return false;
				uSleep(1000);
			}
		}	
		return $skt;
	}


	public function checkWriteOk($socket)
	{
		$ok = false;
		$cc =  0;
		while($ok == false)
		{
			if(++$cc > 2){return false;}
			$ret = socket_read($socket, 1000);
		  if($ret == "RPRT 0\n") {return true;}
		}	
		return false;
	}

	public function hamlibRead($catString)
	{
		global $info;
		global $readMask;
		global $answerMask;
		global $answerBytes;
		global $Coder;
		global $rxab;
		set_time_limit(20);
		if($readMask == "xxx") {return "ERRORHL_READ_XXX";}
		$socket = $this->socketCreateConnect();
		if($socket == false) {return "ERRORHL_SOCKET";}
		socket_write($socket, $catString);
		$ans = socket_read($socket, 1000);
		socket_write($socket, "q\n");		
		if($this->checkWriteOk($socket) == false){$ret = "ERRORHL_WRITE_Q";}
		socket_close($socket);
		if(substr($catString,0,12) == "\send_cmd_rx")
		{
		 	$answerBytes = strlen($answerMask);
			if($answerBytes < 3) {return "ERRORHL_SEND_CMD_RX";}
			$Coder->ParseAnswer($ans, $ans);
		}
		return $ans;
	}



	public function hamlibSet($catString)
	{
		global $info;
		global $setMask;
		global $port;
		global $sendCmdRx;
		$ret = "ERRORHL_WRITE_OK";
		set_time_limit(20);			
		if($setMask == "xxx") {return "ERRORHL_READ_XXX";}
		$socket = $this->socketCreateConnect();
		if($socket == false) {return "ERRORHL_SOCKET";}
		socket_write($socket, $catString);
		if($sendCmdRx)  
		{
			$ret = socket_read($socket, 1000);
		}
		else
		{
			if($this->checkWriteOk($socket) == false) {$ret = "ERRORHL_WRITE";}
		}	 
		socket_write($socket, "q\n");		
		if($this->checkWriteOk($socket) == false){$ret = "ERRORHL_WRITE_Q";}
		socket_close($socket);
		return $ret;
	}


}
?>