
<?php

require_once 'wctaskmysql.php';
require_once 'PhpSerial.php';

require_once 'wcmodcat.php';
	

///////////////////////////////////////////////////////////////////////////////////

$StartTime = 0;


$RPiCom = new RPiComClass;


	
	
class RPiComClass
{	


	public function SetHexWord($pos, $pindex)
	{
		global $dbin;
		$n = hexdec(ltrim($_POST[$pindex],'0'));
		$dbin[$pos] = chr($n % 256);
		$dbin[$pos + 1] = chr(floor($n / 256));
	}

	public function SetDecWord($pos, $pindex)
	{
		global $dbin;
		$n = intVal($_POST[$pindex]);
		$dbin[$pos] = chr($n % 256);
		$dbin[$pos + 1] = chr(floor($n / 256));
	}


	
	public function InitialiseSerial()
	{
		global $serial;
		global $tty;
		$serial->deviceSet($tty);
	}


	public function SendCommand($commandString, $sendBytes, $answerBytes, $storeSvar, $useSvar)
	{
		global $serial;	
		global $catcomms;
		global $connection;
		global $modcat;
		global $rigfix;
		global $portRxBytes;
		global $extractCount;
		global $extractStart;
		global $Coder;
		global $answerMask;
		global $hexAnsX;
		global $hexAnsY;
		global $hexAnsEval;
		
		global $StartTime;
		
		$StartTime = round(microtime(true) * 1000);
		
		$portRxBytes = $answerBytes;
		$extractCount = 0;
		$hexAnsX = false;
		$hexAnsY = false;
		$hexToDec = false;
		$hexToDec2sC = false;
		
		if($catcomms == 'YAESU5')
		{
			if($Coder->processY5AnswerMask()  == false)//{answerBytes = 0;};
			{
				$extractCount = 0;
				$portRxBytes = 0;		
			}

			$commandString = $this->TextToFiveBytes($commandString); 			
			$sendBytes = 5;   /// ALL YAESU5 command are 5 bytes. Responses vary
		}			
		if($connection == 'ENCAT')
		{
			$ps = pack("C5",0,0,0,0,0);
			$ps = "$$$" . chr($sendBytes) . chr($portRxBytes);
		  $commandString = $ps . $commandString;
		  $sendBytes += 5;
		}
		if(($useSvar != 'nosvar') && (isset($_SESSION[$useSvar])))
		{			
			$answer = $_SESSION[$useSvar];
		}
		else
		{	
			// normal read from rig
			//$bc = strlen($com);
			$this->InitialiseSerial();		
			$serial->deviceOpen();
			$serial->sendMessage($commandString, $sendBytes);
			
			if($portRxBytes == 0)
			{
				$serial->deviceClose();
				return "";
			}		
			$answer = $serial->readPortString($portRxBytes);  
			$serial->deviceClose();	
		}
		if($storeSvar != 'nostore') {$_SESSION[$storeSvar] = $answer;}

		if($catcomms == 'YAESU5')
		{
			if($extractCount > 0)
			{
				$answer = substr($answer, $extractStart, $extractCount);			
				$answer = $Coder->AnswerY5toText($answer);
			}
		}			

		return $answer;
	}
	

	public function TextToFiveBytes($text)   // ten characters to five hex bytes
  {
		if(strlen($text) != 10){return '';};
		$five = pack("C5",0,0,0,0,0);
		for($i=0;$i<5;$i++)
		{
			$charpair = substr($text,2*$i,2);
			$five[$i] = chr(hexdec(ltrim($charpair,'0')));
			if($charpair == '--') {$five[$i] = chr(1);};    // clarifier - shift
			if($charpair == '++') {$five[$i] = chr(0);};		// clarifier +shift
		}
		if(ord($five[4]) == 0x07)   // mode setting
		{
			if(ord($five[0]) == 0x10){$five[0] = chr(0x0A);};
			if(ord($five[0]) == 0x12){$five[0] = chr(0x0C);};			
		}	
		return $five;
	}
	



} // end class



	
	

?>
